/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.c) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/


extern rtx_insn *gen_peephole2_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_3 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_3 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_4 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_5 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_4 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_6 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_5 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_6 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_7 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_8 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_9 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_10 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_11 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_12 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_7 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_8 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_9 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_10 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_11 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_12 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_13 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_14 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_15 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_16 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_17 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_18 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_19 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_20 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_21 (rtx_insn *, rtx *);




static int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!arith11_operand (operands[2], SImode))
    return -1;
  return 0;
}

static int
pattern1 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case SFmode:
      if (!register_operand (operands[1], SFmode))
        return -1;
      return 0;

    case DFmode:
      if (!register_operand (operands[1], DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != FIX)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      return pattern1 (x2, SImode); /* [-1, 1] */

    case DImode:
      res = pattern1 (x2, DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[6] = x7;
  if (!register_operand (operands[6], SImode))
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  operands[7] = x9;
  if (!register_operand (operands[7], SImode))
    return -1;
  x10 = XVECEXP (x1, 0, 5);
  x11 = XEXP (x10, 0);
  operands[8] = x11;
  if (!register_operand (operands[8], SImode))
    return -1;
  x12 = XVECEXP (x1, 0, 6);
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  if (!arith14_operand (operands[4], SImode))
    return -1;
  x14 = XVECEXP (x1, 0, 7);
  x15 = XEXP (x14, 0);
  operands[5] = x15;
  if (!const_int_operand (operands[5], SImode))
    return -1;
  return 0;
}

static int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != USE)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != USE)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  if (!memory_operand (operands[0], BLKmode))
    return -1;
  x11 = XEXP (x2, 1);
  operands[1] = x11;
  if (!memory_operand (operands[1], BLKmode)
      || pattern3 (x1) != 0)
    return -1;
  return 0;
}

static int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2
      || GET_MODE (x3) != SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 19
      || GET_MODE (x6) != SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  return 0;
}

static int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 1
      || GET_MODE (x3) != SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER
      || pattern5 (x1) != 0)
    return -1;
  return 0;
}

static int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case DFmode:
      return pattern7 (x1, DFmode); /* [-1, 0] */

    case SFmode:
      if (pattern7 (x1, SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern9 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != SImode)
    return -1;
  return 0;
}

static int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CALL:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != MEM
          || GET_MODE (x2) != SImode)
        return -1;
      return 0;

    case SET:
      x3 = XEXP (x1, 1);
      if (GET_CODE (x3) != CALL)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern11 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], SImode))
    return -1;
  return 0;
}

static int
pattern12 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case TRAP_IF:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != NE)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != i1)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SIGN_EXTEND)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != SIGN_EXTEND)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != SIGN_EXTEND)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != i1)
        return -1;
      x9 = XEXP (x2, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x1, 0, 0);
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      x12 = XEXP (x10, 1);
      x13 = XEXP (x12, 0);
      operands[1] = x13;
      x14 = XEXP (x12, 1);
      operands[2] = x14;
      x15 = XEXP (x5, 0);
      if (!rtx_equal_p (x15, operands[1]))
        return -1;
      x16 = XEXP (x6, 0);
      if (!rtx_equal_p (x16, operands[2]))
        return -1;
      x17 = XEXP (x8, 0);
      if (!rtx_equal_p (x17, operands[1]))
        return -1;
      x18 = XEXP (x8, 1);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case DImode:
          return 0;

        case SImode:
          return 1;

        default:
          return -1;
        }

    case SET:
      x9 = XEXP (x2, 1);
      if (GET_CODE (x9) != MULT)
        return -1;
      x10 = XVECEXP (x1, 0, 0);
      x11 = XEXP (x10, 0);
      operands[3] = x11;
      if (!register_operand (operands[3], VOIDmode))
        return -1;
      x12 = XEXP (x10, 1);
      x13 = XEXP (x12, 0);
      operands[4] = x13;
      if (!register_operand (operands[4], VOIDmode))
        return -1;
      x14 = XEXP (x12, 1);
      operands[5] = x14;
      if (!register_operand (operands[5], VOIDmode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], VOIDmode))
        return -1;
      x19 = XEXP (x9, 0);
      operands[1] = x19;
      if (!register_operand (operands[1], VOIDmode))
        return -1;
      x20 = XEXP (x9, 1);
      operands[2] = x20;
      if (!register_operand (operands[2], VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern13 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC_VOLATILE
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH)
    return -1;
  return 0;
}

static int
pattern14 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 26
      || GET_MODE (x4) != SImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 29
      || GET_MODE (x5) != SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x3, 1);
  operands[0] = x8;
  if (!div_operand (operands[0], SImode))
    return -1;
  x9 = XEXP (x6, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], SImode))
    return -1;
  x10 = XEXP (x7, 0);
  operands[2] = x10;
  if (!register_operand (operands[2], SImode))
    return -1;
  return 0;
}

static int
pattern15 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 26
      || GET_MODE (x4) != SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 25
      || GET_MODE (x5) != SImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 29
      || GET_MODE (x6) != SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x7, 0);
  operands[0] = x9;
  if (!register_operand (operands[0], SImode))
    return -1;
  x10 = XEXP (x8, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], SImode))
    return -1;
  return 0;
}

static int
pattern16 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != SImode)
    return -1;
  return 0;
}

static int
pattern17 (rtx x1, unsigned int i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  return pattern16 (x4, i2, i3); /* [-1, 0] */
}

static int
pattern18 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!reg_or_0_operand (operands[1], SImode))
    return -1;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  if (!arith5_operand (operands[2], SImode))
    return -1;
  return 0;
}

static int
pattern19 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case SImode:
      if (!register_operand (operands[1], SImode))
        return -1;
      return 0;

    case DImode:
      if (!register_operand (operands[1], DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != SImode
      || !register_operand (operands[0], SImode)
      || GET_MODE (x1) != SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  return 0;
}

static int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!uint5_operand (operands[2], SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], SImode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], SImode))
    return -1;
  x5 = XEXP (x3, 2);
  operands[3] = x5;
  if (!uint5_operand (operands[3], SImode))
    return -1;
  return 0;
}

static int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 26
      || GET_MODE (x2) != SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 25
      || GET_MODE (x3) != SImode)
    return -1;
  return 0;
}

static int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 0
      || GET_MODE (x1) != SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 26
      || GET_MODE (x2) != SImode)
    return -1;
  return 0;
}

static int
pattern24 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != UNSPEC_VOLATILE
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != USE)
    return -1;
  return 0;
}

static int
pattern25 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != USE)
    return -1;
  return 0;
}

static int
pattern26 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

static int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CONST_INT:
      operands[2] = x1;
      if (!const_int_operand (operands[2], SImode))
        return -1;
      return 0;

    case MINUS:
      if (GET_MODE (x1) != SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return -1;
      x3 = XEXP (x1, 1);
      operands[2] = x3;
      if (!register_operand (operands[2], SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XWINT (x3, 0) != 0L)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != BLKmode)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != USE)
    return -1;
  return 0;
}

static int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 1
      || GET_MODE (x6) != SImode)
    return -1;
  return 0;
}

static int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 26
      || GET_MODE (x4) != SImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 29
      || GET_MODE (x5) != SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 26
      || GET_MODE (x7) != SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 25
      || GET_MODE (x9) != SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 31
      || GET_MODE (x11) != SImode)
    return -1;
  x12 = XEXP (x3, 1);
  operands[0] = x12;
  if (!div_operand (operands[0], SImode))
    return -1;
  x13 = XVECEXP (x1, 0, 1);
  x14 = XEXP (x13, 0);
  operands[1] = x14;
  if (!register_operand (operands[1], SImode))
    return -1;
  x15 = XVECEXP (x1, 0, 2);
  x16 = XEXP (x15, 0);
  operands[2] = x16;
  if (!register_operand (operands[2], SImode))
    return -1;
  return 0;
}

static int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 26
      || GET_MODE (x4) != SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 25
      || GET_MODE (x5) != SImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 29
      || GET_MODE (x6) != SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 26
      || GET_MODE (x8) != SImode)
    return -1;
  x9 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 25
      || GET_MODE (x10) != SImode)
    return -1;
  x11 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 31
      || GET_MODE (x12) != SImode)
    return -1;
  x13 = XVECEXP (x1, 0, 1);
  x14 = XEXP (x13, 0);
  operands[0] = x14;
  if (!register_operand (operands[0], SImode))
    return -1;
  x15 = XVECEXP (x1, 0, 2);
  x16 = XEXP (x15, 0);
  operands[1] = x16;
  if (!register_operand (operands[1], SImode))
    return -1;
  return 0;
}

static int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != SImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_CODE (x7) != LABEL_REF)
    return -1;
  x8 = XEXP (x3, 2);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XEXP (x2, 0);
  if (GET_CODE (x9) != PC)
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x10) != SET)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PLUS
      || GET_MODE (x11) != SImode)
    return -1;
  return 0;
}

static int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2
      || GET_MODE (x4) != SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != MINUS
      || GET_MODE (x5) != SImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS
      || GET_MODE (x6) != SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x6, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
      || pattern17 (x1, 25, 2, CLOBBER) != 0)
    return -1;
  return 0;
}

static int
pattern34 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], SImode))
    return -1;
  x6 = XEXP (x3, 2);
  operands[1] = x6;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
      if (!uint5_operand (operands[1], SImode))
        return -1;
      x7 = XEXP (x1, 1);
      switch (GET_CODE (x7))
        {
        case LABEL_REF:
          x8 = XEXP (x1, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          return 0;

        case PC:
          x8 = XEXP (x1, 2);
          if (GET_CODE (x8) != LABEL_REF)
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          return 1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      if (!register_operand (operands[1], SImode))
        return -1;
      x7 = XEXP (x1, 1);
      switch (GET_CODE (x7))
        {
        case LABEL_REF:
          x8 = XEXP (x1, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          return 2;

        case PC:
          x8 = XEXP (x1, 2);
          if (GET_CODE (x8) != LABEL_REF)
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
pattern36 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern37 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

static int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != ABS)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x2, 0);
  operands[2] = x8;
  x9 = XEXP (x3, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case DFmode:
      return pattern37 (x1, DFmode); /* [-1, 0] */

    case SFmode:
      if (pattern37 (x1, SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern39 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

static int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MULT)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x2, 0);
  operands[3] = x9;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case DFmode:
      return pattern39 (x1, DFmode); /* [-1, 0] */

    case SFmode:
      if (pattern39 (x1, SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2
      || GET_MODE (x3) != SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != MINUS
      || GET_MODE (x4) != SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x5, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x8 = XEXP (x1, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 25
      || GET_MODE (x8) != SImode)
    return -1;
  return 0;
}

static int
pattern42 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern43 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  if (!register_operand (operands[4], SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!arith14_operand (operands[2], SImode))
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!const_int_operand (operands[3], SImode))
    return -1;
  return 0;
}

static int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!memory_operand (operands[0], BLKmode)
      || pattern44 (x1) != 0)
    return -1;
  return 0;
}

static int
pattern46 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

static int
pattern47 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !arith14_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern48 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != i2)
    return -1;
  x5 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x6) != i1)
    return -1;
  return 0;
}

static int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 29
      || GET_MODE (x3) != SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], SImode))
    return -1;
  return 0;
}

static int
pattern50 (rtx x1, rtx_code i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i2
      || GET_MODE (x5) != SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != i1)
    return -1;
  return 0;
}

static int
pattern51 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 29
      || GET_MODE (x3) != SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 26
      || GET_MODE (x5) != SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i1
      || GET_MODE (x7) != SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 31
      || GET_MODE (x9) != SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 0);
  operands[0] = x11;
  if (!register_operand (operands[0], SImode))
    return -1;
  return 0;
}

static int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x5;
      if (!call_operand_address (operands[1], VOIDmode))
        return -1;
      return 0;

    case REG:
      if (REGNO (x5) != 22
          || GET_MODE (x5) != SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern53 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[0], i1))
    return -1;
  return 0;
}

static int
pattern54 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 1
      || GET_MODE (x3) != SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 19
      || GET_MODE (x5) != SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

static int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CLOBBER:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 2
          || GET_MODE (x2) != SImode)
        return -1;
      return 0;

    case USE:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 2
          || GET_MODE (x2) != SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!pmode_register_operand (operands[0], VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!pmode_register_operand (operands[1], VOIDmode))
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!pmode_register_operand (operands[2], VOIDmode))
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!pmode_register_operand (operands[3], VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 6);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!pmode_register_operand (operands[4], VOIDmode))
    return -1;
  return 0;
}

static int
pattern57 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[0], i1)
      || !scratch_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern58 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x5, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

static int
pattern59 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

static int
pattern60 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !arith11_operand (operands[1], i1)
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  return pattern59 (x5, i1, i2); /* [-1, 0] */
}

static int
pattern61 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[0] = x4;
      if (!call_operand_address (operands[0], VOIDmode))
        return -1;
      x5 = XVECEXP (x1, 0, 5);
      x6 = XEXP (x5, 0);
      if (XWINT (x6, 0) != 0L)
        return -1;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      x8 = XVECEXP (x1, 0, 3);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      return 0;

    case REG:
      if (REGNO (x4) != 22
          || GET_MODE (x4) != SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 5);
      x6 = XEXP (x5, 0);
      if (XWINT (x6, 0) != 1L)
        return -1;
      x7 = XEXP (x2, 1);
      operands[0] = x7;
      x8 = XVECEXP (x1, 0, 3);
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      return 1;

    default:
      return -1;
    }
}

static int
pattern62 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !arith11_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  return pattern59 (x5, i1, i2); /* [-1, 0] */
}

static int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x6;
      if (!call_operand_address (operands[1], VOIDmode))
        return -1;
      x7 = XVECEXP (x1, 0, 5);
      x8 = XEXP (x7, 0);
      if (XWINT (x8, 0) != 0L)
        return -1;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      operands[3] = x11;
      return 0;

    case REG:
      if (REGNO (x6) != 22
          || GET_MODE (x6) != SImode)
        return -1;
      x7 = XVECEXP (x1, 0, 5);
      x8 = XEXP (x7, 0);
      if (XWINT (x8, 0) != 1L)
        return -1;
      x9 = XEXP (x4, 1);
      operands[1] = x9;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      return 1;

    default:
      return -1;
    }
}

static int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 19
      || GET_MODE (x4) != SImode)
    return -1;
  return 0;
}

static int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x3;
      if (!reg_or_cint_move_operand (operands[1], SImode))
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], SImode)
          || GET_MODE (x2) != SImode)
        return -1;
      x5 = XEXP (x2, 0);
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      if (!register_operand (operands[3], SImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      if (!arith11_operand (operands[4], SImode))
        return -1;
      x8 = XEXP (x2, 2);
      if (x8 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          operands[2] = x5;
          return 28; /* *pa.md:1264 */
        }
      operands[5] = x5;
      operands[2] = x8;
      if (!reg_or_cint_move_operand (operands[2], SImode))
        return -1;
      return 29; /* *pa.md:1281 */

    case LABEL_REF:
      if (pattern18 (x1, PC) != 0)
        return -1;
      x9 = XEXP (x3, 0);
      operands[0] = x9;
      return 30; /* *pa.md:1413 */

    case PC:
      if (pattern18 (x1, LABEL_REF) != 0)
        return -1;
      x8 = XEXP (x2, 2);
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      return 31; /* *pa.md:1442 */

    default:
      return -1;
    }
}

static int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MULT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x4, 0);
  operands[0] = x8;
  x9 = XEXP (x6, 0);
  operands[1] = x9;
  switch (XWINT (x5, 0))
    {
    case 4L:
      if (pattern53 (x2, SImode) != 0)
        return -1;
      if (
#line 7018 "../../gcc/config/pa/pa.md"
(!flag_pic))
        {
          *pnum_clobbers = 1;
          return 198; /* casesi32 */
        }
      if (!
#line 7031 "../../gcc/config/pa/pa.md"
(flag_pic))
        return -1;
      *pnum_clobbers = 2;
      return 199; /* casesi32p */

    case 8L:
      if (pattern53 (x2, DImode) != 0)
        return -1;
      *pnum_clobbers = 2;
      return 200; /* casesi64p */

    default:
      return -1;
    }
}

static int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == REG
          && REGNO (x3) == 0
          && GET_MODE (x3) == CCFPmode)
        {
          switch (XWINT (x2, 0))
            {
            case 0L:
              if (
#line 740 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return 3; /* *movccfp0 */
              break;

            case 1L:
              if (
#line 748 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return 4; /* *movccfp1 */
              break;

            default:
              break;
            }
        }
      break;

    case REG:
    case SUBREG:
      operands[0] = x2;
      if (pmode_register_operand (operands[0], VOIDmode))
        {
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == PC)
            return 196; /* indirect_jump */
        }
      break;

    default:
      break;
    }
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != ZERO_EXTRACT
      || GET_MODE (x3) != SImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  if (!uint5_operand (operands[1], SImode))
    return -1;
  x6 = XEXP (x3, 2);
  operands[2] = x6;
  if (!uint5_operand (operands[2], SImode))
    return -1;
  if (arith5_operand (operands[3], SImode)
      && 
#line 8964 "../../gcc/config/pa/pa.md"
(UINTVAL (operands[1]) > 0
   && UINTVAL (operands[1]) + UINTVAL (operands[2]) <= 32))
    return 226; /* insv_32 */
  if (!const_int_operand (operands[3], SImode)
      || !
#line 8978 "../../gcc/config/pa/pa.md"
((INTVAL (operands[3]) & 0x10) != 0 &&
   (~INTVAL (operands[3]) & ((1L << INTVAL (operands[1])) - 1) & ~0xf) == 0))
    return -1;
  return 227; /* *pa.md:8973 */
}

static int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case MEM:
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case REG:
    case SUBREG:
      res = recog_3 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      if (move_dest_operand (operands[0], SImode)
          && move_src_operand (operands[1], SImode))
        {
          if (
#line 2190 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && !TARGET_SOFT_FLOAT
   && !TARGET_64BIT))
            return 42; /* *pa.md:2185 */
          if (
#line 2218 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && !TARGET_SOFT_FLOAT
   && TARGET_64BIT))
            return 43; /* *pa.md:2213 */
        }
      if (indexed_memory_operand (operands[0], SImode)
          && register_operand (operands[1], SImode)
          && 
#line 2242 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && reload_completed))
        return 44; /* *pa.md:2239 */
      if (!move_dest_operand (operands[0], SImode)
          || !move_src_operand (operands[1], SImode)
          || !
#line 2362 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && TARGET_SOFT_FLOAT))
        return -1;
      return 45; /* *pa.md:2357 */

    case HImode:
      if (!move_dest_operand (operands[0], HImode)
          || !move_src_operand (operands[1], HImode)
          || !
#line 2890 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], HImode)
    || reg_or_0_operand (operands[1], HImode))))
        return -1;
      return 60; /* *pa.md:2885 */

    case QImode:
      if (!move_dest_operand (operands[0], QImode)
          || !move_src_operand (operands[1], QImode)
          || !
#line 3050 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode))))
        return -1;
      return 65; /* *pa.md:3045 */

    case DFmode:
      if (move_dest_operand (operands[0], DFmode)
          && reg_or_0_or_nonsymb_mem_operand (operands[1], DFmode)
          && 
#line 3838 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], DFmode)
    || reg_or_0_operand (operands[1], DFmode))
   && !(GET_CODE (operands[1]) == CONST_DOUBLE
	&& GET_CODE (operands[0]) == MEM)
   && !TARGET_64BIT
   && !TARGET_SOFT_FLOAT))
        return 74; /* *pa.md:3833 */
      if (indexed_memory_operand (operands[0], DFmode)
          && reg_or_0_operand (operands[1], DFmode)
          && 
#line 3859 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && reload_completed))
        return 75; /* *pa.md:3856 */
      if (!move_dest_operand (operands[0], DFmode))
        return -1;
      if (reg_or_0_or_nonsymb_mem_operand (operands[1], DFmode)
          && 
#line 4012 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], DFmode)
    || reg_or_0_operand (operands[1], DFmode))
   && !TARGET_64BIT
   && TARGET_SOFT_FLOAT))
        return 76; /* *pa.md:4007 */
      if (!move_src_operand (operands[1], DFmode)
          || !
#line 4028 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], DFmode)
    || reg_or_0_operand (operands[1], DFmode))
   && !TARGET_SOFT_FLOAT && TARGET_64BIT))
        return -1;
      return 77; /* *pa.md:4023 */

    case DImode:
      if (!move_dest_operand (operands[0], DImode)
          || !move_src_operand (operands[1], DImode))
        return -1;
      if (
#line 4161 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], DImode)
    || reg_or_0_operand (operands[1], DImode))
   && !TARGET_64BIT
   && !TARGET_SOFT_FLOAT))
        return 79; /* *pa.md:4156 */
      if (!
#line 4183 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], DImode)
    || reg_or_0_operand (operands[1], DImode))
   && !TARGET_SOFT_FLOAT && TARGET_64BIT))
        return -1;
      return 80; /* *pa.md:4178 */

    case SFmode:
      if (move_dest_operand (operands[0], SFmode)
          && reg_or_0_or_nonsymb_mem_operand (operands[1], SFmode))
        {
          if (
#line 4371 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && !TARGET_SOFT_FLOAT
   && !TARGET_64BIT))
            return 83; /* *pa.md:4366 */
          if (
#line 4393 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && !TARGET_SOFT_FLOAT
   && TARGET_64BIT))
            return 84; /* *pa.md:4388 */
        }
      if (indexed_memory_operand (operands[0], SFmode)
          && register_operand (operands[1], SFmode)
          && 
#line 4411 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && reload_completed))
        return 85; /* *pa.md:4408 */
      if (!move_dest_operand (operands[0], SFmode)
          || !reg_or_0_or_nonsymb_mem_operand (operands[1], SFmode)
          || !
#line 4529 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && TARGET_SOFT_FLOAT))
        return -1;
      return 86; /* *pa.md:4524 */

    default:
      return -1;
    }
}

static int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      if (!register_operand (operands[0], SImode)
          || GET_MODE (x3) != SImode)
        return -1;
      if (
#line 2675 "../../gcc/config/pa/pa.md"
(symbolic_operand (operands[1], Pmode)
   && ! function_label_operand (operands[1], Pmode)
   && ! read_only_operand (operands[1], Pmode)
   && ! flag_pic))
        return 56; /* *pa.md:2672 */
      if (!
#line 2723 "../../gcc/config/pa/pa.md"
((!flag_pic || !symbolic_operand (operands[1], Pmode))
    && !pa_is_function_label_plus_const (operands[1])))
        return -1;
      return 58; /* *pa.md:2720 */

    case DImode:
      if (!register_operand (operands[0], DImode)
          || GET_MODE (x3) != DImode)
        return -1;
      return 78; /* *pa.md:4106 */

    default:
      return -1;
    }
}

static int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != SImode
      || !register_operand (operands[0], SImode))
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
    case LTGT:
      operands[3] = x3;
      if (!comparison_operator (operands[3], SImode))
        return -1;
      x4 = XEXP (x2, 1);
      if (!comparison_operator (x4, SImode))
        return -1;
      operands[6] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      if (!arith11_operand (operands[2], SImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[4] = x7;
      if (!reg_or_0_operand (operands[4], SImode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[5] = x8;
      if (!arith11_operand (operands[5], SImode))
        return -1;
      return 6; /* iorscc */

    case REG:
    case SUBREG:
      operands[1] = x3;
      if (!register_operand (operands[1], SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          if (!cint_ior_operand (operands[2], SImode))
            return -1;
          return 133; /* *pa.md:5737 */

        case REG:
        case SUBREG:
          if (!register_operand (operands[2], SImode))
            return -1;
          return 134; /* *pa.md:5746 */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x3) != SImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != MINUS
          || GET_MODE (x6) != SImode)
        return -1;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      switch (GET_CODE (operands[1]))
        {
        case CONST_INT:
          if (!const_int_operand (operands[1], SImode)
              || XWINT (x9, 0) != 31L)
            return -1;
          x10 = XEXP (x6, 1);
          operands[2] = x10;
          if (!register_operand (operands[2], SImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[3] = x4;
          if (!register_operand (operands[3], SImode)
              || !
#line 6388 "../../gcc/config/pa/pa.md"
(exact_log2 (INTVAL (operands[1]) + 1) > 0))
            return -1;
          return 177; /* vdepi_ior */

        case REG:
        case SUBREG:
          if (!register_operand (operands[1], SImode)
              || XWINT (x9, 0) != 32L)
            return -1;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != LSHIFTRT
              || GET_MODE (x4) != SImode)
            return -1;
          x10 = XEXP (x6, 1);
          operands[3] = x10;
          if (!shift5_operand (operands[3], SImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], SImode))
            return -1;
          x8 = XEXP (x4, 1);
          if (!rtx_equal_p (x8, operands[3]))
            return -1;
          return 182; /* shrpsi4 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
    case LTGT:
      if (!register_operand (operands[0], SImode)
          || GET_MODE (x2) != SImode)
        return -1;
      if (GET_MODE (x3) == SImode)
        {
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (register_operand (operands[2], SImode))
            {
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              x6 = XEXP (x2, 1);
              operands[1] = x6;
              if (register_operand (operands[1], SImode))
                {
                  switch (GET_CODE (x3))
                    {
                    case LEU:
                      if (arith11_operand (operands[3], SImode))
                        return 8; /* *pa.md:840 */
                      break;

                    case GEU:
                      if (register_operand (operands[3], SImode))
                        return 9; /* *pa.md:862 */
                      break;

                    case GTU:
                      if (int11_operand (operands[3], SImode))
                        return 10; /* *pa.md:885 */
                      break;

                    default:
                      break;
                    }
                }
            }
        }
      operands[4] = x3;
      if (!comparison_operator (operands[4], SImode))
        return -1;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!register_operand (operands[2], SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!arith11_operand (operands[3], SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!register_operand (operands[1], SImode))
        return -1;
      return 11; /* incscc */

    case REG:
    case SUBREG:
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case HIGH:
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case SImode:
              if (pattern46 (x2, SImode) != 0)
                return -1;
              if (
#line 2627 "../../gcc/config/pa/pa.md"
(symbolic_operand (operands[2], Pmode)
   && ! function_label_operand (operands[2], Pmode)
   && flag_pic))
                return 52; /* *pa.md:2623 */
              if (!const_int_operand (operands[2], VOIDmode)
                  || !
#line 2702 "../../gcc/config/pa/pa.md"
(reload_completed))
                return -1;
              return 57; /* *pa.md:2698 */

            case DImode:
              if (pattern46 (x2, DImode) != 0
                  || !
#line 2638 "../../gcc/config/pa/pa.md"
(symbolic_operand (operands[2], Pmode)
   && ! function_label_operand (operands[2], Pmode)
   && TARGET_64BIT
   && flag_pic))
                return -1;
              return 53; /* *pa.md:2634 */

            default:
              return -1;
            }

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case HImode:
              if (pattern47 (x2, HImode) != 0)
                return -1;
              return 64; /* addhi3 */

            case DImode:
              if (!register_operand (operands[0], DImode)
                  || GET_MODE (x2) != DImode
                  || !register_operand (operands[1], DImode)
                  || !arith11_operand (operands[2], DImode))
                return -1;
              return 113; /* *pa.md:4933 */

            case SImode:
              if (pattern47 (x2, SImode) != 0)
                return -1;
              return 116; /* addsi3 */

            case DFmode:
              if (pattern7 (x2, DFmode) != 0
                  || !
#line 5890 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 142; /* adddf3 */

            case SFmode:
              if (pattern7 (x2, SFmode) != 0
                  || !
#line 5900 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 143; /* addsf3 */

            default:
              return -1;
            }

        case MINUS:
          if (GET_MODE (x6) != SImode)
            return -1;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != LABEL_REF
              || GET_MODE (x8) != SImode
              || !register_operand (operands[0], SImode)
              || GET_MODE (x2) != SImode
              || !register_operand (operands[1], SImode))
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          return 191; /* load_offset_label_address */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x3) != SImode
          || !register_operand (operands[0], SImode)
          || GET_MODE (x2) != SImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], SImode))
        return -1;
      return 114; /* *pa.md:4974 */

    case ASHIFT:
      if (pattern20 (x2) != 0
          || !shadd_operand (operands[3], SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!register_operand (operands[1], SImode))
        return -1;
      return 172; /* *pa.md:6266 */

    case MULT:
      if (pattern20 (x2) != 0
          || !mem_shadd_operand (operands[3], SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!register_operand (operands[1], SImode))
        return -1;
      return 173; /* *pa.md:6276 */

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x3, 0) != 1
          || !register_operand (operands[0], SImode)
          || GET_MODE (x2) != SImode
          || GET_MODE (x3) != SImode)
        return -1;
      x10 = XVECEXP (x3, 0, 0);
      operands[1] = x10;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 6:
          if (!tld_symbolic_operand (operands[1], VOIDmode))
            return -1;
          *pnum_clobbers = 1;
          return 252; /* tld_offset_load */

        case 9:
          if (!tle_symbolic_operand (operands[1], VOIDmode))
            return -1;
          *pnum_clobbers = 1;
          return 256; /* tle_load */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
        case LTGT:
          if (!register_operand (operands[0], SImode)
              || GET_MODE (x3) != SImode
              || !register_operand (operands[1], SImode))
            return -1;
          if (GET_MODE (x5) == SImode)
            {
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              if (register_operand (operands[2], SImode))
                {
                  x7 = XEXP (x5, 1);
                  operands[3] = x7;
                  switch (GET_CODE (x5))
                    {
                    case GTU:
                      if (arith11_operand (operands[3], SImode))
                        return 12; /* *pa.md:931 */
                      break;

                    case LTU:
                      if (register_operand (operands[3], SImode))
                        return 14; /* *pa.md:975 */
                      break;

                    case LEU:
                      if (int11_operand (operands[3], SImode))
                        return 16; /* *pa.md:1020 */
                      break;

                    default:
                      break;
                    }
                }
            }
          operands[4] = x5;
          if (!comparison_operator (operands[4], SImode))
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], SImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          if (!arith11_operand (operands[3], SImode))
            return -1;
          return 18; /* decscc */

        case CONST_INT:
        case CONST_DOUBLE:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case DImode:
              if (!register_operand (operands[0], DImode)
                  || GET_MODE (x3) != DImode
                  || !arith11_operand (operands[1], DImode)
                  || !reg_or_0_operand (operands[2], DImode))
                return -1;
              return 118; /* *pa.md:5148 */

            case SImode:
              if (!register_operand (operands[0], SImode)
                  || GET_MODE (x3) != SImode
                  || !arith11_operand (operands[1], SImode)
                  || !register_operand (operands[2], SImode))
                return -1;
              if (
#line 5244 "../../gcc/config/pa/pa.md"
(!TARGET_PA_20))
                return 120; /* *pa.md:5240 */
              if (!
#line 5255 "../../gcc/config/pa/pa.md"
(TARGET_PA_20))
                return -1;
              return 121; /* *pa.md:5251 */

            case DFmode:
              if (pattern7 (x3, DFmode) != 0
                  || !
#line 5910 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 144; /* subdf3 */

            case SFmode:
              if (pattern7 (x3, SFmode) != 0
                  || !
#line 5920 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 145; /* subsf3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (pattern11 (x3, SImode) != 0)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_MODE (x8) != SImode)
        return -1;
      x5 = XEXP (x3, 1);
      operands[4] = x5;
      if (!register_operand (operands[4], SImode))
        return -1;
      switch (GET_CODE (x8))
        {
        case GTU:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], SImode))
            return -1;
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (!arith11_operand (operands[3], SImode))
            return -1;
          return 13; /* *pa.md:951 */

        case LTU:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], SImode))
            return -1;
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (!register_operand (operands[3], SImode))
            return -1;
          return 15; /* *pa.md:995 */

        case LEU:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], SImode))
            return -1;
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (!int11_operand (operands[3], SImode))
            return -1;
          return 17; /* *pa.md:1040 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
    case LTGT:
      operands[3] = x4;
      if (!comparison_operator (operands[3], SImode)
          || !register_operand (operands[0], SImode)
          || GET_MODE (x3) != SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!arith11_operand (operands[2], SImode))
        return -1;
      return 7; /* negscc */

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case DImode:
          if (!register_operand (operands[0], DImode)
              || GET_MODE (x3) != DImode
              || !register_operand (operands[1], DImode))
            return -1;
          return 136; /* *pa.md:5786 */

        case SImode:
          if (!register_operand (operands[0], SImode)
              || GET_MODE (x3) != SImode
              || !register_operand (operands[1], SImode))
            return -1;
          return 138; /* negsi2 */

        case DFmode:
          if (!register_operand (operands[0], DFmode)
              || GET_MODE (x3) != DFmode
              || !register_operand (operands[1], DFmode))
            return -1;
          if (
#line 5983 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && !TARGET_PA_20))
            return 150; /* negdf2_slow */
          if (!
#line 6000 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT))
            return -1;
          return 151; /* negdf2_fast */

        case SFmode:
          if (!register_operand (operands[0], SFmode)
              || GET_MODE (x3) != SFmode
              || !register_operand (operands[1], SFmode))
            return -1;
          if (
#line 6026 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && !TARGET_PA_20))
            return 152; /* negsf2_slow */
          if (!
#line 6034 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT))
            return -1;
          return 153; /* negsf2_fast */

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case DFmode:
          if (pattern26 (x3, DFmode) != 0
              || !
#line 6125 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
            return -1;
          return 162; /* *pa.md:6122 */

        case SFmode:
          if (pattern26 (x3, SFmode) != 0
              || !
#line 6133 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
            return -1;
          return 163; /* *pa.md:6130 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case DFmode:
          if (pattern34 (x3, DFmode) != 0
              || !
#line 6182 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros))
            return -1;
          return 166; /* *pa.md:6178 */

        case SFmode:
          if (pattern34 (x3, SFmode) != 0
              || !
#line 6191 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros))
            return -1;
          return 167; /* *pa.md:6187 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case IOR:
      res = recog_6 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PLUS:
      res = recog_7 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case XOR:
      if (GET_MODE (x3) == SImode
          && register_operand (operands[0], SImode))
        {
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (register_operand (operands[1], SImode))
            {
              x5 = XEXP (x3, 1);
              operands[2] = x5;
              if (register_operand (operands[2], SImode))
                return 135; /* xorsi3 */
            }
        }
      break;

    default:
      break;
    }
  if (!register_operand (operands[0], SImode))
    return -1;
  operands[5] = x3;
  if (!plus_xor_ior_operator (operands[5], SImode))
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != SImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case ASHIFT:
      if (GET_CODE (x5) != LSHIFTRT)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], SImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], SImode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], SImode))
        return -1;
      x9 = XEXP (x5, 1);
      operands[4] = x9;
      if (!const_int_operand (operands[4], SImode)
          || !
#line 6691 "../../gcc/config/pa/pa.md"
(INTVAL (operands[3]) + INTVAL (operands[4]) == 32))
        return -1;
      return 185; /* *pa.md:6684 */

    case LSHIFTRT:
      if (GET_CODE (x5) != ASHIFT)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], SImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[4] = x7;
      if (!const_int_operand (operands[4], SImode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], SImode))
        return -1;
      x9 = XEXP (x5, 1);
      operands[3] = x9;
      if (!const_int_operand (operands[3], SImode)
          || !
#line 6703 "../../gcc/config/pa/pa.md"
(INTVAL (operands[3]) + INTVAL (operands[4]) == 32))
        return -1;
      return 186; /* *pa.md:6696 */

    default:
      return -1;
    }
}

static int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
    case MEM:
      res = recog_4 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST:
    case LABEL_REF:
      operands[1] = x2;
      if (pic_label_operand (operands[1], VOIDmode))
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (pmode_register_operand (operands[0], VOIDmode))
            {
              if (
#line 2533 "../../gcc/config/pa/pa.md"
(TARGET_PA_20))
                return 50; /* *pa.md:2530 */
              if (
#line 2583 "../../gcc/config/pa/pa.md"
(!TARGET_PA_20))
                return 51; /* *pa.md:2580 */
            }
        }
      if (GET_CODE (x2) == LABEL_REF)
        {
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == PC)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              return 195; /* jump */
            }
        }
      break;

    case HIGH:
      res = recog_5 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  if (general_operand (operands[1], DImode))
    {
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (move_dest_operand (operands[0], DImode)
          && 
#line 4274 "../../gcc/config/pa/pa.md"
((register_operand (operands[0], DImode)
    || reg_or_0_operand (operands[1], DImode))
   && !TARGET_64BIT
   && TARGET_SOFT_FLOAT))
        return 81; /* *pa.md:4269 */
    }
  if (pnum_clobbers != NULL
      && reg_or_0_operand (operands[1], DImode))
    {
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == MEM
          && GET_MODE (x3) == DImode)
        {
          x5 = XEXP (x3, 0);
          operands[0] = x5;
          if (register_operand (operands[0], SImode)
              && 
#line 10086 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && !TARGET_DISABLE_FPREGS && !TARGET_SOFT_FLOAT))
            {
              *pnum_clobbers = 1;
              return 258; /* atomic_storedi_1 */
            }
        }
    }
  if (pnum_clobbers == NULL
      || GET_CODE (x2) != MEM
      || GET_MODE (x2) != DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], DImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], SImode)
      || !
#line 10045 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && !TARGET_DISABLE_FPREGS && !TARGET_SOFT_FLOAT))
    return -1;
  *pnum_clobbers = 1;
  return 257; /* atomic_loaddi_1 */
}

static int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], SImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!and_operand (operands[2], SImode))
        return -1;
      return 131; /* andsi3 */

    case NOT:
      if (GET_MODE (x4) != SImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], SImode))
        return -1;
      return 132; /* *pa.md:5695 */

    case ROTATE:
      if (GET_MODE (x4) != SImode)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != MINUS
          || GET_MODE (x7) != SImode)
        return -1;
      x8 = XEXP (x7, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!const_int_operand (operands[1], SImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      if (!register_operand (operands[3], SImode)
          || !
#line 6405 "../../gcc/config/pa/pa.md"
(INTVAL (operands[1]) == -2))
        return -1;
      return 178; /* vdepi_and */

    case ASHIFT:
      if (GET_MODE (x4) != SImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], SImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (!const_int_operand (operands[2], SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      if (!const_int_operand (operands[3], SImode)
          || !
#line 6713 "../../gcc/config/pa/pa.md"
(exact_log2 (1 + (INTVAL (operands[3]) >> (INTVAL (operands[2]) & 31))) > 0))
        return -1;
      return 187; /* *pa.md:6708 */

    default:
      return -1;
    }
}

static int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case QImode:
      if (!register_operand (operands[0], QImode)
          || GET_MODE (x3) != QImode
          || !register_operand (operands[1], QImode))
        return -1;
      return 23; /* absqi2 */

    case HImode:
      if (!register_operand (operands[0], HImode)
          || GET_MODE (x3) != HImode
          || !register_operand (operands[1], HImode))
        return -1;
      return 24; /* abshi2 */

    case SImode:
      if (!register_operand (operands[0], SImode)
          || GET_MODE (x3) != SImode
          || !register_operand (operands[1], SImode))
        return -1;
      return 25; /* abssi2 */

    case DFmode:
      if (!register_operand (operands[0], DFmode)
          || GET_MODE (x3) != DFmode
          || !register_operand (operands[1], DFmode)
          || !
#line 6048 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
        return -1;
      return 154; /* absdf2 */

    case SFmode:
      if (!register_operand (operands[0], SFmode)
          || GET_MODE (x3) != SFmode
          || !register_operand (operands[1], SFmode)
          || !
#line 6056 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
        return -1;
      return 155; /* abssf2 */

    default:
      return -1;
    }
}

static int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
      if (!const_int_operand (operands[1], SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case SFmode:
          if (!register_operand (operands[0], SFmode)
              || GET_MODE (x3) != SFmode
              || !
#line 4741 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 95; /* *pa.md:4738 */

        case DFmode:
          if (!register_operand (operands[0], DFmode)
              || GET_MODE (x3) != DFmode
              || !
#line 4760 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 97; /* *pa.md:4757 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case SFmode:
          switch (pattern19 (x3, SFmode))
            {
            case 0:
              if (!
#line 4749 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 96; /* floatsisf2 */

            case 1:
              if (!
#line 4812 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 99; /* floatdisf2 */

            default:
              return -1;
            }

        case DFmode:
          switch (pattern19 (x3, DFmode))
            {
            case 0:
              if (!
#line 4768 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 98; /* floatsidf2 */

            case 1:
              if (!
#line 4820 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 100; /* floatdidf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!comparison_operator (operands[2], VOIDmode)
      || pattern32 (x1) != 0)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!reg_before_reload_operand (operands[0], SImode))
    return -1;
  x7 = XEXP (x5, 1);
  operands[1] = x7;
  if (!int5_operand (operands[1], SImode))
    return -1;
  x8 = XEXP (x3, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 1);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[0]))
    return -1;
  x13 = XEXP (x11, 1);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  x14 = XEXP (x10, 0);
  if (!rtx_equal_p (x14, operands[0]))
    return -1;
  *pnum_clobbers = 1;
  return 228; /* decrement_and_branch_until_zero */
}

static int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case MEM:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case PLUS:
              if (GET_MODE (x4) != SImode)
                return -1;
              x5 = XEXP (x4, 0);
              switch (GET_CODE (x5))
                {
                case REG:
                case SUBREG:
                  operands[1] = x5;
                  if (!register_operand (operands[1], SImode))
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x6) != SET)
                    return -1;
                  x7 = XEXP (x6, 1);
                  if (GET_CODE (x7) != PLUS
                      || GET_MODE (x7) != SImode)
                    return -1;
                  x8 = XEXP (x2, 0);
                  operands[0] = x8;
                  x9 = XEXP (x4, 1);
                  operands[2] = x9;
                  x10 = XEXP (x7, 0);
                  if (!rtx_equal_p (x10, operands[1]))
                    return -1;
                  x11 = XEXP (x7, 1);
                  if (!rtx_equal_p (x11, operands[2]))
                    return -1;
                  x12 = XEXP (x6, 0);
                  if (!rtx_equal_p (x12, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case SImode:
                      if (!register_operand (operands[0], SImode)
                          || GET_MODE (x3) != SImode
                          || !pre_cint_operand (operands[2], SImode))
                        return -1;
                      return 46; /* pre_ldw */

                    case HImode:
                      if (!register_operand (operands[0], HImode)
                          || GET_MODE (x3) != HImode
                          || !int5_operand (operands[2], SImode))
                        return -1;
                      return 61; /* *pa.md:2905 */

                    case QImode:
                      if (!register_operand (operands[0], QImode)
                          || GET_MODE (x3) != QImode
                          || !int5_operand (operands[2], SImode))
                        return -1;
                      return 66; /* *pa.md:3065 */

                    default:
                      return -1;
                    }

                case MULT:
                  if (GET_MODE (x5) != SImode)
                    return -1;
                  x13 = XEXP (x5, 1);
                  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
                    return -1;
                  x9 = XEXP (x4, 1);
                  if (GET_CODE (x9) != LABEL_REF)
                    return -1;
                  x8 = XEXP (x2, 0);
                  if (GET_CODE (x8) != PC)
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x6) != CLOBBER
                      || GET_MODE (x3) != SImode)
                    return -1;
                  x14 = XEXP (x5, 0);
                  operands[0] = x14;
                  if (!register_operand (operands[0], SImode))
                    return -1;
                  x15 = XEXP (x9, 0);
                  operands[1] = x15;
                  x12 = XEXP (x6, 0);
                  operands[2] = x12;
                  if (!scratch_operand (operands[2], SImode)
                      || !
#line 7018 "../../gcc/config/pa/pa.md"
(!flag_pic))
                    return -1;
                  return 198; /* casesi32 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!register_operand (operands[1], SImode))
                return -1;
              x8 = XEXP (x2, 0);
              operands[0] = x8;
              x6 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x6))
                {
                case SET:
                  x7 = XEXP (x6, 1);
                  if (GET_CODE (x7) != PLUS
                      || GET_MODE (x7) != SImode
                      || !register_operand (operands[0], SImode)
                      || GET_MODE (x3) != SImode)
                    return -1;
                  x11 = XEXP (x7, 1);
                  operands[2] = x11;
                  if (!post_cint_operand (operands[2], SImode))
                    return -1;
                  x10 = XEXP (x7, 0);
                  if (!rtx_equal_p (x10, operands[1]))
                    return -1;
                  x12 = XEXP (x6, 0);
                  if (!rtx_equal_p (x12, operands[1]))
                    return -1;
                  return 48; /* *pa.md:2466 */

                case CLOBBER:
                  if (!register_operand (operands[0], DImode)
                      || GET_MODE (x3) != DImode)
                    return -1;
                  x12 = XEXP (x6, 0);
                  operands[2] = x12;
                  if (!scratch_operand (operands[2], DImode)
                      || !
#line 10045 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && !TARGET_DISABLE_FPREGS && !TARGET_SOFT_FLOAT))
                    return -1;
                  return 257; /* atomic_loaddi_1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_DOUBLE:
        case REG:
        case SUBREG:
          x8 = XEXP (x2, 0);
          switch (GET_CODE (x8))
            {
            case MEM:
              x16 = XEXP (x8, 0);
              switch (GET_CODE (x16))
                {
                case PLUS:
                  if (GET_MODE (x16) != SImode)
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x6) != SET)
                    return -1;
                  x7 = XEXP (x6, 1);
                  if (GET_CODE (x7) != PLUS
                      || GET_MODE (x7) != SImode)
                    return -1;
                  x17 = XEXP (x16, 0);
                  operands[0] = x17;
                  if (!register_operand (operands[0], SImode))
                    return -1;
                  x18 = XEXP (x16, 1);
                  operands[1] = x18;
                  operands[2] = x3;
                  x10 = XEXP (x7, 0);
                  if (!rtx_equal_p (x10, operands[0]))
                    return -1;
                  x11 = XEXP (x7, 1);
                  if (!rtx_equal_p (x11, operands[1]))
                    return -1;
                  x12 = XEXP (x6, 0);
                  if (!rtx_equal_p (x12, operands[0]))
                    return -1;
                  switch (GET_MODE (x8))
                    {
                    case SImode:
                      if (!pre_cint_operand (operands[1], SImode)
                          || !reg_or_0_operand (operands[2], SImode))
                        return -1;
                      return 47; /* *pa.md:2450 */

                    case HImode:
                      if (!int5_operand (operands[1], SImode)
                          || !reg_or_0_operand (operands[2], HImode))
                        return -1;
                      return 63; /* *pa.md:2967 */

                    case QImode:
                      if (!int5_operand (operands[1], SImode)
                          || !reg_or_0_operand (operands[2], QImode))
                        return -1;
                      return 69; /* *pa.md:3141 */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  operands[0] = x16;
                  if (!register_operand (operands[0], SImode))
                    return -1;
                  operands[1] = x3;
                  x6 = XVECEXP (x1, 0, 1);
                  switch (GET_CODE (x6))
                    {
                    case SET:
                      x7 = XEXP (x6, 1);
                      if (GET_CODE (x7) != PLUS
                          || GET_MODE (x7) != SImode
                          || GET_MODE (x8) != SImode
                          || !reg_or_0_operand (operands[1], SImode))
                        return -1;
                      x11 = XEXP (x7, 1);
                      operands[2] = x11;
                      if (!post_cint_operand (operands[2], SImode))
                        return -1;
                      x10 = XEXP (x7, 0);
                      if (!rtx_equal_p (x10, operands[0]))
                        return -1;
                      x12 = XEXP (x6, 0);
                      if (!rtx_equal_p (x12, operands[0]))
                        return -1;
                      return 49; /* post_stw */

                    case CLOBBER:
                      if (GET_MODE (x8) != DImode
                          || !reg_or_0_operand (operands[1], DImode))
                        return -1;
                      x12 = XEXP (x6, 0);
                      operands[2] = x12;
                      if (!scratch_operand (operands[2], DImode)
                          || !
#line 10086 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && !TARGET_DISABLE_FPREGS && !TARGET_SOFT_FLOAT))
                        return -1;
                      return 258; /* atomic_storedi_1 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case PC:
              x6 = XVECEXP (x1, 0, 1);
              if (pattern9 (x6, 2, CLOBBER) != 0)
                return -1;
              operands[0] = x3;
              if (!pmode_register_operand (operands[0], VOIDmode))
                return -1;
              if (
#line 8656 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && !TARGET_64BIT))
                return 219; /* *pa.md:8653 */
              if (
#line 8664 "../../gcc/config/pa/pa.md"
(TARGET_NO_SPACE_REGS && !TARGET_64BIT))
                return 220; /* *pa.md:8661 */
              return 221; /* *pa.md:8669 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != MEM)
            return -1;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != PLUS
              || GET_MODE (x5) != SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != PLUS
              || GET_MODE (x7) != SImode)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          x14 = XEXP (x5, 0);
          operands[1] = x14;
          if (!register_operand (operands[1], SImode))
            return -1;
          x13 = XEXP (x5, 1);
          operands[2] = x13;
          if (!int5_operand (operands[2], SImode))
            return -1;
          x10 = XEXP (x7, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XEXP (x7, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          x12 = XEXP (x6, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case SImode:
              if (!register_operand (operands[0], SImode)
                  || GET_MODE (x3) != SImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case HImode:
                  return 62; /* *pa.md:2941 */

                case QImode:
                  return 67; /* *pa.md:3097 */

                default:
                  return -1;
                }

            case HImode:
              if (!register_operand (operands[0], HImode)
                  || GET_MODE (x3) != HImode
                  || GET_MODE (x4) != QImode)
                return -1;
              return 68; /* *pa.md:3119 */

            default:
              return -1;
            }

        case PLUS:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case REG:
            case SUBREG:
              switch (pattern12 (x1, PLUS))
                {
                case 0:
                  if (pattern62 (x1, DImode, TImode) != 0)
                    return -1;
                  return 115; /* *pa.md:5011 */

                case 1:
                  if (pattern62 (x1, SImode, DImode) != 0)
                    return -1;
                  return 117; /* addvsi3 */

                case 2:
                  if (!
#line 9444 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT
   && reload_completed && pa_fmpyaddoperands (operands)))
                    return -1;
                  return 237; /* *pa.md:9437 */

                default:
                  return -1;
                }

            case UNSPEC:
              if (XVECLEN (x4, 0) != 1)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (pattern9 (x6, 1, CLOBBER) != 0)
                return -1;
              x8 = XEXP (x2, 0);
              operands[0] = x8;
              if (!register_operand (operands[0], SImode)
                  || GET_MODE (x3) != SImode
                  || GET_MODE (x4) != SImode)
                return -1;
              x19 = XVECEXP (x4, 0, 0);
              operands[1] = x19;
              x20 = XEXP (x3, 1);
              operands[2] = x20;
              if (!register_operand (operands[2], SImode))
                return -1;
              switch (XINT (x4, 1))
                {
                case 6:
                  if (!tld_symbolic_operand (operands[1], VOIDmode))
                    return -1;
                  return 252; /* tld_offset_load */

                case 9:
                  if (!tle_symbolic_operand (operands[1], VOIDmode))
                    return -1;
                  return 256; /* tle_load */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MINUS:
          switch (pattern12 (x1, MINUS))
            {
            case 0:
              if (pattern60 (x1, DImode, TImode) != 0)
                return -1;
              return 119; /* *pa.md:5202 */

            case 1:
              if (pattern60 (x1, SImode, DImode) != 0)
                return -1;
              return 122; /* subvsi3 */

            case 2:
              if (!
#line 9492 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT
   && reload_completed && pa_fmpysuboperands (operands)))
                return -1;
              return 239; /* *pa.md:9485 */

            default:
              return -1;
            }

        case MULT:
          if (pnum_clobbers != NULL
              && pattern22 (x3) == 0
              && pattern49 (x1) == 0)
            {
              *pnum_clobbers = 3;
              return 126; /* *pa.md:5347 */
            }
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (!register_operand (operands[0], VOIDmode))
            return -1;
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], VOIDmode))
            return -1;
          x20 = XEXP (x3, 1);
          operands[2] = x20;
          if (!register_operand (operands[2], VOIDmode))
            return -1;
          x12 = XEXP (x6, 0);
          operands[3] = x12;
          if (!register_operand (operands[3], VOIDmode))
            return -1;
          x7 = XEXP (x6, 1);
          switch (GET_CODE (x7))
            {
            case PLUS:
              x10 = XEXP (x7, 0);
              operands[4] = x10;
              if (!register_operand (operands[4], VOIDmode))
                return -1;
              x11 = XEXP (x7, 1);
              operands[5] = x11;
              if (!register_operand (operands[5], VOIDmode)
                  || !
#line 9415 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT
   && reload_completed && pa_fmpyaddoperands (operands)))
                return -1;
              return 236; /* *pa.md:9408 */

            case MINUS:
              x10 = XEXP (x7, 0);
              operands[4] = x10;
              if (!register_operand (operands[4], VOIDmode))
                return -1;
              x11 = XEXP (x7, 1);
              operands[5] = x11;
              if (!register_operand (operands[5], VOIDmode)
                  || !
#line 9473 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT
   && reload_completed && pa_fmpysuboperands (operands)))
                return -1;
              return 238; /* *pa.md:9466 */

            default:
              return -1;
            }

        case NEG:
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != TRAP_IF)
                return -1;
              x12 = XEXP (x6, 0);
              if (GET_CODE (x12) != NE)
                return -1;
              x21 = XEXP (x12, 0);
              if (GET_CODE (x21) != NEG)
                return -1;
              x22 = XEXP (x21, 0);
              if (GET_CODE (x22) != SIGN_EXTEND)
                return -1;
              x23 = XEXP (x12, 1);
              if (GET_CODE (x23) != SIGN_EXTEND)
                return -1;
              x24 = XEXP (x23, 0);
              if (GET_CODE (x24) != NEG)
                return -1;
              x7 = XEXP (x6, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x25 = XEXP (x22, 0);
              if (!rtx_equal_p (x25, operands[1]))
                return -1;
              x26 = XEXP (x24, 0);
              if (!rtx_equal_p (x26, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case DImode:
                  if (pattern58 (x1, DImode, TImode) != 0)
                    return -1;
                  return 137; /* *pa.md:5811 */

                case SImode:
                  if (pattern58 (x1, SImode, DImode) != 0)
                    return -1;
                  return 139; /* negvsi2 */

                default:
                  return -1;
                }

            case ABS:
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != SET)
                return -1;
              switch (pattern38 (x1))
                {
                case 0:
                  if (!
#line 6142 "../../gcc/config/pa/pa.md"
((! TARGET_SOFT_FLOAT && TARGET_PA_20
    && ! reg_overlap_mentioned_p (operands[2], operands[1]))))
                    return -1;
                  return 164; /* *pa.md:6138 */

                case 1:
                  if (!
#line 6161 "../../gcc/config/pa/pa.md"
((! TARGET_SOFT_FLOAT && TARGET_PA_20
    && ! reg_overlap_mentioned_p (operands[2], operands[1]))))
                    return -1;
                  return 165; /* *pa.md:6157 */

                default:
                  return -1;
                }

            case MULT:
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != SET)
                return -1;
              switch (pattern40 (x1))
                {
                case 0:
                  if (!
#line 6202 "../../gcc/config/pa/pa.md"
((!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros
    && ! (reg_overlap_mentioned_p (operands[3], operands[1])
          || reg_overlap_mentioned_p (operands[3], operands[2])))))
                    return -1;
                  return 168; /* *pa.md:6196 */

                case 1:
                  if (!
#line 6226 "../../gcc/config/pa/pa.md"
((!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros
    && ! (reg_overlap_mentioned_p (operands[3], operands[1])
          || reg_overlap_mentioned_p (operands[3], operands[2])))))
                    return -1;
                  return 169; /* *pa.md:6220 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case LABEL_REF:
          x8 = XEXP (x2, 0);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              operands[0] = x8;
              if (!register_operand (operands[0], SImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || GET_MODE (x3) != SImode)
                return -1;
              x4 = XEXP (x3, 0);
              operands[1] = x4;
              if (
#line 6826 "../../gcc/config/pa/pa.md"
(!TARGET_PA_20))
                return 192; /* lcla1 */
              if (!
#line 6841 "../../gcc/config/pa/pa.md"
(TARGET_PA_20))
                return -1;
              return 193; /* lcla2 */

            case PC:
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != SET)
                return -1;
              x12 = XEXP (x6, 0);
              operands[0] = x12;
              x7 = XEXP (x6, 1);
              switch (GET_CODE (x7))
                {
                case PLUS:
                  if (GET_MODE (x7) != SImode)
                    return -1;
                  x4 = XEXP (x3, 0);
                  operands[3] = x4;
                  if (!ireg_operand (operands[0], SImode))
                    return -1;
                  x10 = XEXP (x7, 0);
                  operands[1] = x10;
                  if (!ireg_operand (operands[1], SImode))
                    return -1;
                  x11 = XEXP (x7, 1);
                  operands[2] = x11;
                  if (!ireg_or_int5_operand (operands[2], SImode)
                      || !
#line 9297 "../../gcc/config/pa/pa.md"
((reload_completed && operands[0] == operands[1]) || operands[0] == operands[2]))
                    return -1;
                  return 231; /* *pa.md:9292 */

                case CONST_INT:
                case REG:
                  operands[1] = x7;
                  x4 = XEXP (x3, 0);
                  operands[2] = x4;
                  switch (GET_MODE (operands[0]))
                    {
                    case SFmode:
                      if (!ireg_operand (operands[0], SFmode)
                          || !ireg_or_int5_operand (operands[1], SFmode)
                          || !
#line 9320 "../../gcc/config/pa/pa.md"
(reload_completed))
                        return -1;
                      return 232; /* *pa.md:9316 */

                    case SImode:
                      if (!ireg_operand (operands[0], SImode)
                          || !ireg_or_int5_operand (operands[1], SImode)
                          || !
#line 9343 "../../gcc/config/pa/pa.md"
(reload_completed))
                        return -1;
                      return 233; /* *pa.md:9339 */

                    case HImode:
                      if (!ireg_operand (operands[0], HImode)
                          || !ireg_or_int5_operand (operands[1], HImode)
                          || !
#line 9366 "../../gcc/config/pa/pa.md"
(reload_completed))
                        return -1;
                      return 234; /* *pa.md:9362 */

                    case QImode:
                      if (!ireg_operand (operands[0], QImode)
                          || !ireg_or_int5_operand (operands[1], QImode)
                          || !
#line 9389 "../../gcc/config/pa/pa.md"
(reload_completed))
                        return -1;
                      return 235; /* *pa.md:9385 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNEQ:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
            case LTGT:
              if (pnum_clobbers != NULL)
                {
                  res = recog_15 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              if (!movb_comparison_operator (x4, VOIDmode))
                return -1;
              operands[2] = x4;
              x9 = XEXP (x4, 1);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x8 = XEXP (x2, 0);
              if (GET_CODE (x8) != PC)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != SET)
                return -1;
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (!register_operand (operands[1], SImode))
                return -1;
              x12 = XEXP (x6, 0);
              operands[0] = x12;
              if (!reg_before_reload_operand (operands[0], SImode))
                return -1;
              x7 = XEXP (x6, 1);
              if (!rtx_equal_p (x7, operands[1]))
                return -1;
              x20 = XEXP (x3, 1);
              switch (GET_CODE (x20))
                {
                case LABEL_REF:
                  x27 = XEXP (x3, 2);
                  if (GET_CODE (x27) != PC)
                    return -1;
                  x28 = XEXP (x20, 0);
                  operands[3] = x28;
                  return 229; /* *pa.md:9149 */

                case PC:
                  x27 = XEXP (x3, 2);
                  if (GET_CODE (x27) != LABEL_REF)
                    return -1;
                  x29 = XEXP (x27, 0);
                  operands[3] = x29;
                  return 230; /* *pa.md:9221 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (pnum_clobbers == NULL
              || pattern23 (x3) != 0
              || pattern49 (x1) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 246; /* *$$sh_func_adrs */

        default:
          return -1;
        }

    case RETURN:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern9 (x6, 2, USE) != 0)
        return -1;
      if (
#line 6730 "../../gcc/config/pa/pa.md"
(pa_can_use_return_insn ()))
        return 188; /* return */
      return 189; /* return_internal */

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET
          || pattern41 (x6) != 0)
        return -1;
      x16 = XEXP (x8, 0);
      operands[0] = x16;
      if (!call_operand_address (operands[0], VOIDmode))
        return -1;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      x7 = XEXP (x6, 1);
      x11 = XEXP (x7, 1);
      x30 = XEXP (x11, 0);
      operands[2] = x30;
      if (!
#line 8315 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 213; /* call_mcount_nonpic */

    default:
      return -1;
    }
}

static int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case DIV:
          if (pattern14 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 127; /* *pa.md:5450 */

        case UDIV:
          if (pattern14 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 128; /* *pa.md:5511 */

        case MOD:
          if (pattern15 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 129; /* *pa.md:5569 */

        case UMOD:
          if (pattern15 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 130; /* *pa.md:5625 */

        case MEM:
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != PLUS)
            return -1;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != MULT)
            return -1;
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != LABEL_REF)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != CLOBBER)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x11 = XEXP (x5, 0);
          operands[0] = x11;
          x12 = XEXP (x7, 0);
          operands[1] = x12;
          x13 = XEXP (x9, 0);
          operands[2] = x13;
          x14 = XEXP (x10, 0);
          operands[3] = x14;
          switch (XWINT (x6, 0))
            {
            case 4L:
              if (pattern57 (x3, SImode) != 0
                  || !
#line 7031 "../../gcc/config/pa/pa.md"
(flag_pic))
                return -1;
              return 199; /* casesi32p */

            case 8L:
              if (pattern57 (x3, DImode) != 0)
                return -1;
              return 200; /* casesi64p */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x4 = XEXP (x3, 0);
          if (!comparison_operator (x4, VOIDmode))
            return -1;
          operands[2] = x4;
          if (pattern32 (x1) != 0)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x5 = XEXP (x4, 0);
          x11 = XEXP (x5, 0);
          operands[0] = x11;
          if (!reg_before_reload_operand (operands[0], SImode))
            return -1;
          x6 = XEXP (x5, 1);
          operands[1] = x6;
          if (!int5_operand (operands[1], SImode))
            return -1;
          x15 = XEXP (x3, 1);
          x16 = XEXP (x15, 0);
          operands[3] = x16;
          x14 = XEXP (x10, 0);
          operands[4] = x14;
          if (!scratch_operand (operands[4], SImode))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x17 = XEXP (x9, 1);
          x18 = XEXP (x17, 0);
          if (!rtx_equal_p (x18, operands[0]))
            return -1;
          x19 = XEXP (x17, 1);
          if (!rtx_equal_p (x19, operands[1]))
            return -1;
          x13 = XEXP (x9, 0);
          if (!rtx_equal_p (x13, operands[0]))
            return -1;
          return 228; /* decrement_and_branch_until_zero */

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || pattern25 (x1, 1, CLOBBER) != 0)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          x14 = XEXP (x10, 0);
          if (GET_CODE (x14) != REG
              || GET_MODE (x14) != SImode)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (!register_operand (operands[0], SImode)
              || GET_MODE (x3) != SImode)
            return -1;
          x20 = XVECEXP (x3, 0, 0);
          operands[1] = x20;
          switch (XINT (x3, 1))
            {
            case 4:
              if (REGNO (x14) != 27
                  || !tgd_symbolic_operand (operands[1], VOIDmode))
                return -1;
              return 248; /* tgd_load */

            case 10:
              if (REGNO (x14) != 19
                  || !tgd_symbolic_operand (operands[1], VOIDmode))
                return -1;
              return 249; /* tgd_load_pic */

            case 5:
              if (REGNO (x14) != 27
                  || !tld_symbolic_operand (operands[1], VOIDmode))
                return -1;
              return 250; /* tld_load */

            case 11:
              if (REGNO (x14) != 19
                  || !tld_symbolic_operand (operands[1], VOIDmode))
                return -1;
              return 251; /* tld_load_pic */

            case 8:
              if (REGNO (x14) != 27
                  || !tie_symbolic_operand (operands[1], VOIDmode))
                return -1;
              return 254; /* tie_load */

            case 12:
              if (REGNO (x14) != 19
                  || !tie_symbolic_operand (operands[1], VOIDmode))
                return -1;
              return 255; /* tie_load_pic */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case RETURN:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != CLOBBER
          || pattern17 (x1, 1, 2, USE) != 0
          || !
#line 6759 "../../gcc/config/pa/pa.md"
(!TARGET_NO_SPACE_REGS
   && !TARGET_PA_20
   && flag_pic && crtl->calls_eh_return))
        return -1;
      return 190; /* return_external_pic */

    case CALL:
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != SImode)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET
          || pattern33 (x1) != 0)
        return -1;
      x21 = XEXP (x8, 0);
      operands[0] = x21;
      if (!call_operand_address (operands[0], VOIDmode))
        return -1;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      x17 = XEXP (x9, 1);
      x19 = XEXP (x17, 1);
      x22 = XEXP (x19, 0);
      operands[2] = x22;
      if (!
#line 8315 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
        return -1;
      return 213; /* call_mcount_nonpic */

    case UNSPEC_VOLATILE:
      if (pnum_clobbers == NULL
          || XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 4)
        return -1;
      x23 = XVECEXP (x2, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != USE
          || pattern17 (x1, 29, 28, USE) != 0)
        return -1;
      *pnum_clobbers = 7;
      return 245; /* outline_epilogue_call */

    default:
      return -1;
    }
}

static int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (pattern28 (x1) != 0)
            return -1;
          x6 = XEXP (x2, 0);
          x7 = XEXP (x6, 0);
          operands[0] = x7;
          if (!register_operand (operands[0], SImode)
              || pattern44 (x1) != 0)
            return -1;
          return 72; /* clrmemsi_prereload */

        case MULT:
          if (pattern22 (x5) != 0
              || pattern51 (x1, 25) != 0)
            return -1;
          return 126; /* *pa.md:5347 */

        case CALL:
          if (pattern29 (x1) != 0
              || pattern50 (x1, USE, 19, 2) != 0)
            return -1;
          x8 = XVECEXP (x1, 0, 4);
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != CONST_INT)
            return -1;
          switch (pattern52 (x2))
            {
            case 0:
              if (XWINT (x9, 0) != 0L)
                return -1;
              x10 = XEXP (x5, 1);
              operands[2] = x10;
              if (!
#line 7802 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                return -1;
              return 209; /* *call_val_symref_pic_post_reload */

            case 1:
              if (XWINT (x9, 0) != 1L)
                return -1;
              x10 = XEXP (x5, 1);
              operands[1] = x10;
              return 212; /* *call_val_reg_pic_post_reload */

            default:
              return -1;
            }

        case UNSPEC:
          if (pattern23 (x5) != 0
              || pattern51 (x1, 22) != 0)
            return -1;
          return 246; /* *$$sh_func_adrs */

        default:
          return -1;
        }

    case CALL:
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (pattern16 (x4, 2, CLOBBER) != 0)
        return -1;
      x8 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x8) != USE)
        return -1;
      x7 = XEXP (x6, 0);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[0] = x7;
          if (!call_operand_address (operands[0], VOIDmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          x3 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x3))
            {
            case CLOBBER:
              if (pattern54 (x1, 0) != 0
                  || !
#line 7288 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                return -1;
              return 203; /* *call_symref_pic_post_reload */

            case SET:
              if (pattern41 (x3) != 0
                  || pattern64 (x1) != 0)
                return -1;
              x11 = XEXP (x3, 1);
              x12 = XEXP (x11, 1);
              x13 = XEXP (x12, 0);
              operands[2] = x13;
              x14 = XVECEXP (x1, 0, 3);
              x15 = XEXP (x14, 0);
              operands[3] = x15;
              if (!
#line 8334 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                return -1;
              return 214; /* call_mcount_pic */

            default:
              return -1;
            }

        case REG:
          if (REGNO (x7) != 22
              || GET_MODE (x7) != SImode)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != CLOBBER
              || pattern54 (x1, 1) != 0)
            return -1;
          x5 = XEXP (x2, 1);
          operands[0] = x5;
          return 206; /* *call_reg_pic_post_reload */

        default:
          return -1;
        }

    case CONST_INT:
      if (pnum_clobbers == NULL
          || XWINT (x2, 0) != 1L
          || pattern24 (x1, 1) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x16 = XEXP (x4, 0);
      operands[0] = x16;
      if (!pmode_register_operand (operands[0], VOIDmode))
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      operands[1] = x15;
      if (!pmode_register_operand (operands[1], VOIDmode))
        return -1;
      x8 = XVECEXP (x1, 0, 4);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!pmode_register_operand (operands[2], VOIDmode))
        return -1;
      if (
#line 115 "../../gcc/config/pa/pa.md"
(Pmode == SImode))
        {
          *pnum_clobbers = 1;
          return 240; /* dcacheflushsi */
        }
      if (!
#line 115 "../../gcc/config/pa/pa.md"
(Pmode == DImode))
        return -1;
      *pnum_clobbers = 1;
      return 241; /* dcacheflushdi */

    default:
      return -1;
    }
}

static int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
    case LTGT:
      operands[2] = x2;
      if (comparison_operator (operands[2], CCFPmode))
        {
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == REG
              && REGNO (x3) == 0
              && GET_MODE (x3) == CCFPmode)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              switch (GET_MODE (operands[0]))
                {
                case SFmode:
                  if (reg_or_0_operand (operands[0], SFmode)
                      && reg_or_0_operand (operands[1], SFmode)
                      && 
#line 704 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                    return 1; /* *pa.md:699 */
                  break;

                case DFmode:
                  if (reg_or_0_operand (operands[0], DFmode)
                      && reg_or_0_operand (operands[1], DFmode)
                      && 
#line 714 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                    return 2; /* *pa.md:709 */
                  break;

                default:
                  break;
                }
            }
        }
      operands[3] = x2;
      if (!comparison_operator (operands[3], SImode))
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!reg_or_0_operand (operands[1], SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!arith11_operand (operands[2], SImode))
        return -1;
      return 5; /* scc */

    case NEG:
      return recog_9 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_8 (x1, insn, pnum_clobbers);

    case SMIN:
      if (pattern0 (x1) != 0)
        return -1;
      return 19; /* sminsi3 */

    case UMIN:
      if (pattern0 (x1) != 0)
        return -1;
      return 20; /* uminsi3 */

    case SMAX:
      if (pattern0 (x1) != 0)
        return -1;
      return 21; /* smaxsi3 */

    case UMAX:
      if (pattern0 (x1) != 0)
        return -1;
      return 22; /* umaxsi3 */

    case ABS:
      return recog_13 (x1, insn, pnum_clobbers);

    case BSWAP:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case HImode:
          if (!register_operand (operands[0], HImode)
              || GET_MODE (x2) != HImode
              || !register_operand (operands[1], HImode))
            return -1;
          return 26; /* bswaphi2 */

        case SImode:
          if (!register_operand (operands[0], SImode)
              || GET_MODE (x2) != SImode
              || !register_operand (operands[1], SImode))
            return -1;
          return 27; /* bswapsi2 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
        case LTGT:
          if (comparison_operator (x4, VOIDmode))
            {
              res = recog_1 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != PC)
            return -1;
          switch (GET_CODE (x4))
            {
            case NE:
              x7 = XEXP (x4, 0);
              switch (GET_CODE (x7))
                {
                case ZERO_EXTRACT:
                  switch (pattern35 (x2))
                    {
                    case 0:
                      return 32; /* *pa.md:1581 */

                    case 1:
                      return 33; /* *pa.md:1637 */

                    case 2:
                      return 36; /* *pa.md:1806 */

                    case 3:
                      return 37; /* *pa.md:1862 */

                    default:
                      return -1;
                    }

                case REG:
                  if (REGNO (x7) != 0
                      || GET_MODE (x7) != CCFPmode)
                    return -1;
                  x5 = XEXP (x2, 1);
                  switch (GET_CODE (x5))
                    {
                    case LABEL_REF:
                      x8 = XEXP (x2, 2);
                      if (GET_CODE (x8) != PC)
                        return -1;
                      x9 = XEXP (x5, 0);
                      operands[0] = x9;
                      if (!
#line 2039 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT))
                        return -1;
                      return 40; /* *pa.md:2035 */

                    case PC:
                      x8 = XEXP (x2, 2);
                      if (GET_CODE (x8) != LABEL_REF)
                        return -1;
                      x10 = XEXP (x8, 0);
                      operands[0] = x10;
                      if (!
#line 2083 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT))
                        return -1;
                      return 41; /* *pa.md:2079 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case EQ:
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != ZERO_EXTRACT)
                return -1;
              switch (pattern35 (x2))
                {
                case 0:
                  return 34; /* *pa.md:1693 */

                case 1:
                  return 35; /* *pa.md:1749 */

                case 2:
                  return 38; /* *pa.md:1918 */

                case 3:
                  return 39; /* *pa.md:1974 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LO_SUM:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case UNSPEC:
          if (XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 2)
            return -1;
          x11 = XVECEXP (x5, 0, 0);
          operands[2] = x11;
          switch (GET_MODE (operands[0]))
            {
            case SImode:
              if (pattern46 (x2, SImode) != 0
                  || !
#line 2650 "../../gcc/config/pa/pa.md"
(symbolic_operand (operands[2], Pmode)
   && ! function_label_operand (operands[2], Pmode)
   && flag_pic))
                return -1;
              return 54; /* *pa.md:2646 */

            case DImode:
              if (pattern46 (x2, DImode) != 0
                  || !
#line 2661 "../../gcc/config/pa/pa.md"
(symbolic_operand (operands[2], Pmode)
   && ! function_label_operand (operands[2], Pmode)
   && TARGET_64BIT
   && flag_pic))
                return -1;
              return 55; /* *pa.md:2657 */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case SImode:
              if (pattern36 (x2, SImode) != 0
                  || !
#line 2756 "../../gcc/config/pa/pa.md"
(!pa_is_function_label_plus_const (operands[2])))
                return -1;
              return 59; /* *pa.md:2752 */

            case DImode:
              if (pattern36 (x2, DImode) != 0)
                return -1;
              return 82; /* *pa.md:4285 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_11 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case HImode:
          if (!register_operand (operands[0], HImode)
              || GET_MODE (x2) != HImode
              || !move_src_operand (operands[1], QImode)
              || !
#line 4559 "../../gcc/config/pa/pa.md"
(GET_CODE (operands[1]) != CONST_INT))
            return -1;
          return 87; /* *pa.md:4555 */

        case SImode:
          if (!register_operand (operands[0], SImode)
              || GET_MODE (x2) != SImode)
            return -1;
          if (move_src_operand (operands[1], QImode)
              && 
#line 4577 "../../gcc/config/pa/pa.md"
(GET_CODE (operands[1]) != CONST_INT))
            return 88; /* *pa.md:4573 */
          if (!move_src_operand (operands[1], HImode)
              || !
#line 4595 "../../gcc/config/pa/pa.md"
(GET_CODE (operands[1]) != CONST_INT))
            return -1;
          return 89; /* *pa.md:4591 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case SImode:
          if (!register_operand (operands[0], SImode)
              || GET_MODE (x2) != SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case HImode:
              if (!register_operand (operands[1], HImode))
                return -1;
              return 90; /* extendhisi2 */

            case QImode:
              if (!register_operand (operands[1], QImode))
                return -1;
              return 92; /* extendqisi2 */

            default:
              return -1;
            }

        case HImode:
          if (!register_operand (operands[0], HImode)
              || GET_MODE (x2) != HImode
              || !register_operand (operands[1], QImode))
            return -1;
          return 91; /* extendqihi2 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x2) != DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], DFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], SFmode)
          || !
#line 4713 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
        return -1;
      return 93; /* extendsfdf2 */

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], DFmode)
          || !
#line 4722 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
        return -1;
      return 94; /* truncdfsf2 */

    case FLOAT:
      return recog_14 (x1, insn, pnum_clobbers);

    case FIX:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 4831 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 101; /* fix_truncsfsi2 */

        case 1:
          if (!
#line 4839 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 102; /* fix_truncdfsi2 */

        case 2:
          if (!
#line 4847 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT))
            return -1;
          return 103; /* fix_truncsfdi2 */

        case 3:
          if (!
#line 4855 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT))
            return -1;
          return 104; /* fix_truncdfdi2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case DFmode:
          switch (pattern19 (x2, DFmode))
            {
            case 0:
              if (!
#line 4863 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                return -1;
              return 105; /* floatunssidf2_pa20 */

            case 1:
              if (!
#line 4887 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                return -1;
              return 108; /* floatunsdidf2 */

            default:
              return -1;
            }

        case SFmode:
          switch (pattern19 (x2, SFmode))
            {
            case 0:
              if (!
#line 4871 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                return -1;
              return 106; /* floatunssisf2_pa20 */

            case 1:
              if (!
#line 4879 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                return -1;
              return 107; /* floatunsdisf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 4895 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
            return -1;
          return 109; /* fixuns_truncsfsi2 */

        case 1:
          if (!
#line 4903 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
            return -1;
          return 110; /* fixuns_truncdfsi2 */

        case 2:
          if (!
#line 4911 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
            return -1;
          return 111; /* fixuns_truncsfdi2 */

        case 3:
          if (!
#line 4919 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
            return -1;
          return 112; /* fixuns_truncdfdi2 */

        default:
          return -1;
        }

    case MULT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTEND:
          if (pattern11 (x2, DImode) != 0)
            return -1;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case ZERO_EXTEND:
              if (GET_MODE (x5) != DImode)
                return -1;
              x9 = XEXP (x5, 0);
              operands[2] = x9;
              if (!register_operand (operands[2], SImode)
                  || !
#line 5324 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_DISABLE_FPREGS && ! TARGET_SOFT_FLOAT))
                return -1;
              return 124; /* umulsidi3 */

            case CONST_INT:
            case CONST_DOUBLE:
              operands[2] = x5;
              if (!uint32_operand (operands[2], DImode)
                  || !
#line 5333 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_DISABLE_FPREGS && ! TARGET_SOFT_FLOAT && !TARGET_64BIT))
                return -1;
              return 125; /* *pa.md:5329 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern8 (x2))
            {
            case 0:
              if (!
#line 5930 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 146; /* muldf3 */

            case 1:
              if (!
#line 5940 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 147; /* mulsf3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      return recog_12 (x1, insn, pnum_clobbers);

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case DImode:
          if (!register_operand (operands[0], DImode)
              || GET_MODE (x2) != DImode
              || !register_operand (operands[1], DImode))
            return -1;
          return 140; /* *pa.md:5860 */

        case SImode:
          if (!register_operand (operands[0], SImode)
              || GET_MODE (x2) != SImode
              || !register_operand (operands[1], SImode))
            return -1;
          return 141; /* one_cmplsi2 */

        default:
          return -1;
        }

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern8 (x2))
        {
        case 0:
          if (!
#line 5950 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 148; /* divdf3 */

        case 1:
          if (!
#line 5959 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 149; /* divsf3 */

        default:
          return -1;
        }

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case DFmode:
          if (!register_operand (operands[0], DFmode)
              || GET_MODE (x2) != DFmode
              || !register_operand (operands[1], DFmode)
              || !
#line 6064 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 156; /* sqrtdf2 */

        case SFmode:
          if (!register_operand (operands[0], SFmode)
              || GET_MODE (x2) != SFmode
              || !register_operand (operands[1], SFmode)
              || !
#line 6072 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 157; /* sqrtsf2 */

        default:
          return -1;
        }

    case FMA:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case DFmode:
              if (pattern42 (x2, DFmode) != 0
                  || !
#line 6085 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 158; /* fmadf4 */

            case SFmode:
              if (pattern42 (x2, SFmode) != 0
                  || !
#line 6095 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 159; /* fmasf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case DFmode:
              if (pattern43 (x2, DFmode) != 0
                  || !
#line 6106 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 160; /* fnmadf4 */

            case SFmode:
              if (pattern43 (x2, SFmode) != 0
                  || !
#line 6116 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 161; /* fnmasf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x2) != SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (memory_operand (operands[1], SImode))
        {
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) == CONST_INT)
            {
              switch (XWINT (x5, 0))
                {
                case 24L:
                  return 170; /* *pa.md:6248 */

                case 16L:
                  return 171; /* *pa.md:6257 */

                default:
                  break;
                }
            }
        }
      if (!register_operand (operands[1], SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!shift5_operand (operands[2], SImode))
        return -1;
      return 181; /* lshrsi3 */

    case ASHIFT:
      if (GET_MODE (x2) != SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      switch (pattern27 (x5))
        {
        case 0:
          if (!register_operand (operands[1], SImode))
            return -1;
          return 174; /* *pa.md:6338 */

        case 1:
          if (arith5_operand (operands[1], SImode))
            return 175; /* zvdep32 */
          if (!lhs_lshift_cint_operand (operands[1], SImode))
            return -1;
          return 176; /* zvdep_imm32 */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (GET_MODE (x2) != SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], SImode))
        return -1;
      x5 = XEXP (x2, 1);
      switch (pattern27 (x5))
        {
        case 0:
          return 179; /* *pa.md:6530 */

        case 1:
          return 180; /* vextrs32 */

        default:
          return -1;
        }

    case ROTATERT:
      if (GET_MODE (x2) != SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!shift5_operand (operands[2], SImode))
        return -1;
      return 183; /* rotrsi3 */

    case ROTATE:
      if (GET_MODE (x2) != SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], SImode))
        return -1;
      return 184; /* *pa.md:6671 */

    case PLUS:
    case IOR:
    case XOR:
      return recog_10 (x1, insn, pnum_clobbers);

    case ZERO_EXTRACT:
      if (GET_MODE (x2) != SImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[2] = x5;
      if (pattern21 (x1) == 0
          && 
#line 8764 "../../gcc/config/pa/pa.md"
(UINTVAL (operands[2]) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[3]) <= 32))
        return 222; /* extzv_32 */
      if (XWINT (x5, 0) != 1L)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], SImode))
        return -1;
      x8 = XEXP (x2, 2);
      operands[2] = x8;
      if (!register_operand (operands[2], SImode))
        return -1;
      return 223; /* *pa.md:8770 */

    case SIGN_EXTRACT:
      if (GET_MODE (x2) != SImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[2] = x5;
      if (pattern21 (x1) == 0
          && 
#line 8864 "../../gcc/config/pa/pa.md"
(UINTVAL (operands[2]) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[3]) <= 32))
        return 224; /* extv_32 */
      if (XWINT (x5, 0) != 1L)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], SImode))
        return -1;
      x8 = XEXP (x2, 2);
      operands[2] = x8;
      if (!register_operand (operands[2], SImode))
        return -1;
      return 225; /* *pa.md:8870 */

    case UNSPEC:
      if (XVECLEN (x2, 0) != 1)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 3:
          if (GET_MODE (x2) != SImode)
            return -1;
          x12 = XVECEXP (x2, 0, 0);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], SImode))
            return -1;
          return 253; /* tp_load */

        case 13:
          if (GET_MODE (x2) != BLKmode)
            return -1;
          x12 = XVECEXP (x2, 0, 0);
          if (!rtx_equal_p (x12, operands[0]))
            return -1;
          return 259; /* *memory_barrier */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_19 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return recog_16 (x1, insn, pnum_clobbers);

        case 8:
          x2 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x2) != CLOBBER)
            return -1;
          x3 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x3))
            {
            case SET:
              x4 = XEXP (x3, 1);
              if (GET_CODE (x4) != MEM
                  || GET_MODE (x4) != BLKmode)
                return -1;
              x5 = XEXP (x3, 0);
              if (GET_CODE (x5) != MEM
                  || GET_MODE (x5) != BLKmode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER
                  || pattern48 (x1, USE, CLOBBER) != 0)
                return -1;
              x7 = XEXP (x5, 0);
              operands[0] = x7;
              if (!register_operand (operands[0], SImode))
                return -1;
              x8 = XEXP (x4, 0);
              operands[1] = x8;
              if (!register_operand (operands[1], SImode)
                  || pattern3 (x1) != 0)
                return -1;
              return 70; /* movmemsi_prereload */

            case CONST_INT:
              if (XWINT (x3, 0) != 2L)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (pattern13 (x6, 2) != 0
                  || pattern48 (x1, CLOBBER, USE) != 0
                  || pattern56 (x1) != 0)
                return -1;
              x9 = XVECEXP (x1, 0, 7);
              x10 = XEXP (x9, 0);
              operands[5] = x10;
              switch (GET_MODE (operands[5]))
                {
                case SImode:
                  if (!scratch_operand (operands[5], SImode)
                      || !
#line 115 "../../gcc/config/pa/pa.md"
(Pmode == SImode))
                    return -1;
                  return 242; /* icacheflushsi */

                case DImode:
                  if (!scratch_operand (operands[5], DImode)
                      || !
#line 115 "../../gcc/config/pa/pa.md"
(Pmode == DImode))
                    return -1;
                  return 243; /* icacheflushdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 9:
          x3 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x3) != SET)
            return -1;
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != BLKmode)
            return -1;
          x5 = XEXP (x3, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != BLKmode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x11 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x11) != CLOBBER)
            return -1;
          x12 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x12) != CLOBBER)
            return -1;
          x13 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x13) != CLOBBER)
            return -1;
          x2 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x2) != CLOBBER)
            return -1;
          x14 = XVECEXP (x1, 0, 6);
          if (GET_CODE (x14) != USE)
            return -1;
          x9 = XVECEXP (x1, 0, 7);
          if (GET_CODE (x9) != USE)
            return -1;
          x15 = XVECEXP (x1, 0, 8);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          if (!register_operand (operands[0], SImode))
            return -1;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], SImode))
            return -1;
          x16 = XEXP (x6, 0);
          operands[2] = x16;
          if (!register_operand (operands[2], SImode))
            return -1;
          x17 = XEXP (x11, 0);
          operands[3] = x17;
          if (!register_operand (operands[3], SImode))
            return -1;
          x18 = XEXP (x12, 0);
          operands[6] = x18;
          if (!register_operand (operands[6], SImode))
            return -1;
          x19 = XEXP (x14, 0);
          operands[4] = x19;
          if (!arith14_operand (operands[4], SImode))
            return -1;
          x10 = XEXP (x9, 0);
          operands[5] = x10;
          if (!const_int_operand (operands[5], SImode))
            return -1;
          x20 = XEXP (x13, 0);
          if (!rtx_equal_p (x20, operands[0]))
            return -1;
          x21 = XEXP (x2, 0);
          if (!rtx_equal_p (x21, operands[1])
              || !
#line 3351 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed))
            return -1;
          return 71; /* movmemsi_postreload */

        case 5:
          return recog_18 (x1, insn, pnum_clobbers);

        case 6:
          x3 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x3))
            {
            case SET:
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER)
                return -1;
              x11 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x11) != CLOBBER)
                return -1;
              x4 = XEXP (x3, 1);
              switch (GET_CODE (x4))
                {
                case CONST_INT:
                  if (pattern28 (x1) != 0)
                    return -1;
                  x2 = XVECEXP (x1, 0, 5);
                  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  x5 = XEXP (x3, 0);
                  x7 = XEXP (x5, 0);
                  operands[0] = x7;
                  if (!register_operand (operands[0], SImode))
                    return -1;
                  x16 = XEXP (x6, 0);
                  operands[1] = x16;
                  if (!register_operand (operands[1], SImode))
                    return -1;
                  x12 = XVECEXP (x1, 0, 3);
                  x18 = XEXP (x12, 0);
                  operands[2] = x18;
                  if (!arith14_operand (operands[2], SImode))
                    return -1;
                  x13 = XVECEXP (x1, 0, 4);
                  x20 = XEXP (x13, 0);
                  operands[3] = x20;
                  if (!const_int_operand (operands[3], SImode))
                    return -1;
                  x17 = XEXP (x11, 0);
                  if (!rtx_equal_p (x17, operands[0])
                      || !
#line 3653 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed))
                    return -1;
                  return 73; /* clrmemsi_postreload */

                case DIV:
                  if (pattern30 (x1) != 0)
                    return -1;
                  return 127; /* *pa.md:5450 */

                case UDIV:
                  if (pattern30 (x1) != 0)
                    return -1;
                  return 128; /* *pa.md:5511 */

                case MOD:
                  if (pattern31 (x1) != 0)
                    return -1;
                  return 129; /* *pa.md:5569 */

                case UMOD:
                  if (pattern31 (x1) != 0)
                    return -1;
                  return 130; /* *pa.md:5625 */

                case CALL:
                  if (pattern29 (x1) != 0
                      || pattern5 (x1) != 0)
                    return -1;
                  switch (pattern63 (x1))
                    {
                    case 0:
                      if (!
#line 7740 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                        return -1;
                      return 208; /* call_val_symref_pic */

                    case 1:
                      return 211; /* call_val_reg_pic */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case CALL:
              x5 = XEXP (x3, 0);
              if (GET_CODE (x5) != MEM
                  || GET_MODE (x5) != SImode
                  || pattern6 (x1) != 0)
                return -1;
              switch (pattern61 (x1))
                {
                case 0:
                  if (!
#line 7231 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                    return -1;
                  return 202; /* call_symref_pic */

                case 1:
                  return 205; /* call_reg_pic */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x3, 0) != 1L)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (pattern13 (x6, 1) != 0)
                return -1;
              x11 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x11) != USE)
                return -1;
              x12 = XVECEXP (x1, 0, 3);
              if (GET_CODE (x12) != USE)
                return -1;
              x13 = XVECEXP (x1, 0, 4);
              if (GET_CODE (x13) != USE)
                return -1;
              x2 = XVECEXP (x1, 0, 5);
              if (GET_CODE (x2) != CLOBBER)
                return -1;
              x17 = XEXP (x11, 0);
              operands[0] = x17;
              if (!pmode_register_operand (operands[0], VOIDmode))
                return -1;
              x18 = XEXP (x12, 0);
              operands[1] = x18;
              if (!pmode_register_operand (operands[1], VOIDmode))
                return -1;
              x20 = XEXP (x13, 0);
              operands[2] = x20;
              if (!pmode_register_operand (operands[2], VOIDmode))
                return -1;
              x21 = XEXP (x2, 0);
              operands[3] = x21;
              switch (GET_MODE (operands[3]))
                {
                case SImode:
                  if (!scratch_operand (operands[3], SImode)
                      || !
#line 115 "../../gcc/config/pa/pa.md"
(Pmode == SImode))
                    return -1;
                  return 240; /* dcacheflushsi */

                case DImode:
                  if (!scratch_operand (operands[3], DImode)
                      || !
#line 115 "../../gcc/config/pa/pa.md"
(Pmode == DImode))
                    return -1;
                  return 241; /* dcacheflushdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3:
          return recog_17 (x1, insn, pnum_clobbers);

        case 4:
          x12 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x12) != USE)
            return -1;
          x3 = XVECEXP (x1, 0, 0);
          switch (pattern10 (x3))
            {
            case 0:
              x5 = XEXP (x3, 0);
              x7 = XEXP (x5, 0);
              switch (GET_CODE (x7))
                {
                case CONST_INT:
                case CONST_DOUBLE:
                case CONST:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[0] = x7;
                  if (!call_operand_address (operands[0], VOIDmode))
                    return -1;
                  x4 = XEXP (x3, 1);
                  operands[1] = x4;
                  x6 = XVECEXP (x1, 0, 1);
                  switch (GET_CODE (x6))
                    {
                    case CLOBBER:
                      x16 = XEXP (x6, 0);
                      if (GET_CODE (x16) != REG
                          || REGNO (x16) != 1
                          || GET_MODE (x16) != SImode)
                        return -1;
                      x18 = XEXP (x12, 0);
                      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                        return -1;
                      x11 = XVECEXP (x1, 0, 2);
                      switch (pattern55 (x11))
                        {
                        case 0:
                          if (!
#line 7212 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                            return -1;
                          return 201; /* call_symref */

                        case 1:
                          if (!
#line 8517 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                            return -1;
                          return 216; /* sibcall_internal_symref */

                        default:
                          return -1;
                        }

                    case SET:
                      if (pattern33 (x1) != 0)
                        return -1;
                      x18 = XEXP (x12, 0);
                      if (GET_CODE (x18) != REG
                          || REGNO (x18) != 19
                          || GET_MODE (x18) != SImode)
                        return -1;
                      x22 = XEXP (x6, 1);
                      x23 = XEXP (x22, 1);
                      x24 = XEXP (x23, 0);
                      operands[2] = x24;
                      if (!
#line 8369 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                        return -1;
                      return 215; /* *call_mcount_pic_post_reload */

                    default:
                      return -1;
                    }

                case REG:
                  if (REGNO (x7) != 22
                      || GET_MODE (x7) != SImode)
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x6) != CLOBBER
                      || pattern17 (x1, 1, 2, CLOBBER) != 0)
                    return -1;
                  x18 = XEXP (x12, 0);
                  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x4 = XEXP (x3, 1);
                  operands[0] = x4;
                  return 204; /* call_reg */

                default:
                  return -1;
                }

            case 1:
              x6 = XVECEXP (x1, 0, 1);
              if (pattern9 (x6, 1, CLOBBER) != 0)
                return -1;
              x18 = XEXP (x12, 0);
              if (GET_CODE (x18) != CONST_INT)
                return -1;
              switch (pattern52 (x3))
                {
                case 0:
                  if (XWINT (x18, 0) != 0L)
                    return -1;
                  x4 = XEXP (x3, 1);
                  x25 = XEXP (x4, 1);
                  operands[2] = x25;
                  x11 = XVECEXP (x1, 0, 2);
                  switch (pattern55 (x11))
                    {
                    case 0:
                      if (!
#line 7700 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                        return -1;
                      return 207; /* call_val_symref */

                    case 1:
                      if (!
#line 8604 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                        return -1;
                      return 217; /* sibcall_value_internal_symref */

                    default:
                      return -1;
                    }

                case 1:
                  x11 = XVECEXP (x1, 0, 2);
                  if (pattern16 (x11, 2, CLOBBER) != 0
                      || XWINT (x18, 0) != 1L)
                    return -1;
                  x4 = XEXP (x3, 1);
                  x25 = XEXP (x4, 1);
                  operands[1] = x25;
                  return 210; /* call_val_reg */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 7:
          x2 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x2) != CLOBBER)
            return -1;
          x14 = XVECEXP (x1, 0, 6);
          if (GET_CODE (x14) != CLOBBER)
            return -1;
          x3 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x3))
            {
            case CONST_INT:
              if (pnum_clobbers == NULL
                  || XWINT (x3, 0) != 2L
                  || pattern24 (x1, 2) != 0
                  || pattern56 (x1) != 0)
                return -1;
              if (
#line 115 "../../gcc/config/pa/pa.md"
(Pmode == SImode))
                {
                  *pnum_clobbers = 1;
                  return 242; /* icacheflushsi */
                }
              if (!
#line 115 "../../gcc/config/pa/pa.md"
(Pmode == DImode))
                return -1;
              *pnum_clobbers = 1;
              return 243; /* icacheflushdi */

            case UNSPEC_VOLATILE:
              if (XVECLEN (x3, 0) != 1
                  || XINT (x3, 1) != 3)
                return -1;
              x26 = XVECEXP (x3, 0, 0);
              if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER)
                return -1;
              x16 = XEXP (x6, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 31
                  || GET_MODE (x16) != SImode)
                return -1;
              x11 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x11) != CLOBBER)
                return -1;
              x17 = XEXP (x11, 0);
              if (GET_CODE (x17) != REG
                  || REGNO (x17) != 22
                  || GET_MODE (x17) != SImode)
                return -1;
              x12 = XVECEXP (x1, 0, 3);
              if (GET_CODE (x12) != CLOBBER)
                return -1;
              x18 = XEXP (x12, 0);
              if (GET_CODE (x18) != REG
                  || REGNO (x18) != 21
                  || GET_MODE (x18) != SImode)
                return -1;
              x13 = XVECEXP (x1, 0, 4);
              if (GET_CODE (x13) != CLOBBER)
                return -1;
              x20 = XEXP (x13, 0);
              if (GET_CODE (x20) != REG
                  || REGNO (x20) != 20
                  || GET_MODE (x20) != SImode)
                return -1;
              x21 = XEXP (x2, 0);
              if (GET_CODE (x21) != REG
                  || REGNO (x21) != 19
                  || GET_MODE (x21) != SImode)
                return -1;
              x19 = XEXP (x14, 0);
              if (GET_CODE (x19) != REG
                  || REGNO (x19) != 1
                  || GET_MODE (x19) != SImode)
                return -1;
              return 244; /* outline_prologue_call */

            default:
              return -1;
            }

        case 10:
          x3 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x3) != UNSPEC_VOLATILE
              || XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 4)
            return -1;
          x26 = XVECEXP (x3, 0, 0);
          if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || pattern25 (x1, 29, USE) != 0
              || pattern50 (x1, CLOBBER, 31, 28) != 0)
            return -1;
          x13 = XVECEXP (x1, 0, 4);
          x20 = XEXP (x13, 0);
          if (GET_CODE (x20) != REG
              || REGNO (x20) != 22
              || GET_MODE (x20) != SImode)
            return -1;
          x2 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x2) != CLOBBER)
            return -1;
          x21 = XEXP (x2, 0);
          if (GET_CODE (x21) != REG
              || REGNO (x21) != 21
              || GET_MODE (x21) != SImode)
            return -1;
          x14 = XVECEXP (x1, 0, 6);
          if (GET_CODE (x14) != CLOBBER)
            return -1;
          x19 = XEXP (x14, 0);
          if (GET_CODE (x19) != REG
              || REGNO (x19) != 20
              || GET_MODE (x19) != SImode)
            return -1;
          x9 = XVECEXP (x1, 0, 7);
          if (GET_CODE (x9) != CLOBBER)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 19
              || GET_MODE (x10) != SImode)
            return -1;
          x15 = XVECEXP (x1, 0, 8);
          if (GET_CODE (x15) != CLOBBER)
            return -1;
          x27 = XEXP (x15, 0);
          if (GET_CODE (x27) != REG
              || REGNO (x27) != 2
              || GET_MODE (x27) != SImode)
            return -1;
          x28 = XVECEXP (x1, 0, 9);
          if (GET_CODE (x28) != CLOBBER)
            return -1;
          x29 = XEXP (x28, 0);
          if (GET_CODE (x29) != REG
              || REGNO (x29) != 1
              || GET_MODE (x29) != SImode)
            return -1;
          return 245; /* outline_epilogue_call */

        default:
          return -1;
        }

    case TRAP_IF:
      x30 = XEXP (x1, 0);
      if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x31 = XEXP (x1, 1);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 123; /* trap */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1)
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x3) != CONST_INT)
        return -1;
      switch (XINT (x1, 1))
        {
        case 0:
          if (XWINT (x3, 0) != 2L)
            return -1;
          return 194; /* blockage */

        case 3:
          if (pnum_clobbers == NULL
              || XWINT (x3, 0) != 0L)
            return -1;
          *pnum_clobbers = 6;
          return 244; /* outline_prologue_call */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 1)
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], VOIDmode)
          || !
#line 6938 "../../gcc/config/pa/pa.md"
(GET_MODE (operands[0]) == word_mode))
        return -1;
      return 197; /* indirect_goto */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 218; /* nop */

    case PREFETCH:
      x30 = XEXP (x1, 0);
      operands[0] = x30;
      if (!pmode_register_operand (operands[0], VOIDmode))
        return -1;
      x31 = XEXP (x1, 1);
      operands[1] = x31;
      if (!const_int_operand (operands[1], SImode))
        return -1;
      x32 = XEXP (x1, 2);
      operands[2] = x32;
      if (!const_int_operand (operands[2], SImode)
          || !
#line 9822 "../../gcc/config/pa/pa.md"
(TARGET_PA_20))
        return -1;
      return 247; /* prefetch_20 */

    default:
      return -1;
    }
}

rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != PARALLEL)
    return NULL;
  switch (XVECLEN (x1, 0))
    {
    case 2:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return NULL;
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x3;
          if (!symbolic_operand (operands[1], SImode))
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], SImode))
            return NULL;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], SImode)
              || !
#line 2778 "../../gcc/config/pa/pa.md"
(! (flag_pic && pic_label_operand (operands[1], SImode))))
            return NULL;
          return gen_split_1 (insn, operands);

        case REG:
        case SUBREG:
          operands[4] = x3;
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != MEM)
            return NULL;
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != PLUS
              || GET_MODE (x7) != SImode)
            return NULL;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != MULT
              || GET_MODE (x8) != SImode)
            return NULL;
          x9 = XEXP (x7, 1);
          if (GET_CODE (x9) != PLUS
              || GET_MODE (x9) != SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x10 = XEXP (x8, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], SImode))
            return NULL;
          x11 = XEXP (x8, 1);
          operands[1] = x11;
          if (!mem_shadd_operand (operands[1], SImode))
            return NULL;
          x12 = XEXP (x9, 0);
          operands[2] = x12;
          if (!register_operand (operands[2], SImode))
            return NULL;
          x13 = XEXP (x9, 1);
          operands[3] = x13;
          if (!const_int_operand (operands[3], SImode))
            return NULL;
          x6 = XEXP (x4, 0);
          operands[5] = x6;
          if (!register_operand (operands[5], SImode))
            return NULL;
          switch (GET_MODE (x5))
            {
            case SImode:
              if (!register_operand (operands[4], SImode))
                return NULL;
              return gen_split_2 (insn, operands);

            case HImode:
              if (!register_operand (operands[4], HImode))
                return NULL;
              return gen_split_3 (insn, operands);

            case QImode:
              if (!register_operand (operands[4], QImode))
                return NULL;
              return gen_split_4 (insn, operands);

            default:
              return NULL;
            }

        case PLUS:
          if (GET_MODE (x3) != SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], SImode))
            return NULL;
          x14 = XEXP (x3, 0);
          operands[1] = x14;
          if (!register_operand (operands[1], SImode))
            return NULL;
          x15 = XEXP (x3, 1);
          operands[2] = x15;
          if (!const_int_operand (operands[2], SImode))
            return NULL;
          x6 = XEXP (x4, 0);
          operands[4] = x6;
          if (!register_operand (operands[4], SImode))
            return NULL;
          if (
#line 5043 "../../gcc/config/pa/pa.md"
(! pa_cint_ok_for_move (UINTVAL (operands[2]))
   && VAL_14_BITS_P (INTVAL (operands[2]) >> 1)))
            return gen_split_7 (insn, operands);
          if (!
#line 5062 "../../gcc/config/pa/pa.md"
(! pa_cint_ok_for_move (UINTVAL (operands[2]))))
            return NULL;
          return gen_split_8 (insn, operands);

        case NEG:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x14 = XEXP (x3, 0);
          switch (GET_CODE (x14))
            {
            case ABS:
              switch (pattern38 (x1))
                {
                case 0:
                  if (!
#line 6152 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                    return NULL;
                  return gen_split_9 (insn, operands);

                case 1:
                  if (!
#line 6171 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                    return NULL;
                  return gen_split_10 (insn, operands);

                default:
                  return NULL;
                }

            case MULT:
              switch (pattern40 (x1))
                {
                case 0:
                  if (!
#line 6215 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros))
                    return NULL;
                  return gen_split_11 (insn, operands);

                case 1:
                  if (!
#line 6239 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_PA_20&& !flag_signed_zeros))
                    return NULL;
                  return gen_split_12 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 8:
      if (pattern4 (x1) != 0
          || !
#line 3271 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed && !flag_peephole2
   && GET_CODE (operands[0]) == MEM
   && register_operand (XEXP (operands[0], 0), SImode)
   && GET_CODE (operands[1]) == MEM
   && register_operand (XEXP (operands[1], 0), SImode)))
        return NULL;
      return gen_split_5 (insn, operands);

    case 5:
      x16 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x16) != CLOBBER)
        return NULL;
      x17 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x17) != USE)
        return NULL;
      x2 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x2))
        {
        case SET:
          x3 = XEXP (x2, 1);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x18 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x18) != USE
              || pattern45 (x1) != 0
              || !
#line 3601 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed && !flag_peephole2
   && GET_CODE (operands[0]) == MEM
   && register_operand (XEXP (operands[0], 0), SImode)))
            return NULL;
          return gen_split_6 (insn, operands);

        case CALL:
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return NULL;
          x19 = XEXP (x4, 1);
          if (GET_CODE (x19) != PLUS
              || GET_MODE (x19) != SImode)
            return NULL;
          x20 = XEXP (x19, 0);
          if (GET_CODE (x20) != REG
              || REGNO (x20) != 2
              || GET_MODE (x20) != SImode)
            return NULL;
          x21 = XEXP (x19, 1);
          if (GET_CODE (x21) != MINUS
              || GET_MODE (x21) != SImode)
            return NULL;
          x22 = XEXP (x21, 1);
          if (GET_CODE (x22) != PLUS
              || GET_MODE (x22) != SImode)
            return NULL;
          x23 = XEXP (x22, 0);
          if (GET_CODE (x23) != PC)
            return NULL;
          x24 = XEXP (x22, 1);
          if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
            return NULL;
          x6 = XEXP (x4, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 25
              || GET_MODE (x6) != SImode)
            return NULL;
          x25 = XEXP (x16, 0);
          if (GET_CODE (x25) != REG
              || REGNO (x25) != 2
              || GET_MODE (x25) != SImode
              || pattern64 (x1) != 0)
            return NULL;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          if (!call_operand_address (operands[0], VOIDmode))
            return NULL;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          x26 = XEXP (x21, 0);
          operands[2] = x26;
          x18 = XVECEXP (x1, 0, 3);
          x27 = XEXP (x18, 0);
          operands[3] = x27;
          if (!
#line 8347 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT && reload_completed))
            return NULL;
          return gen_split_21 (insn, operands);

        default:
          return NULL;
        }

    case 6:
      if (pattern6 (x1) != 0)
        return NULL;
      x2 = XVECEXP (x1, 0, 0);
      switch (pattern10 (x2))
        {
        case 0:
          switch (pattern61 (x1))
            {
            case 0:
              if (
#line 7251 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT && reload_completed
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                return gen_split_13 (insn, operands);
              if (!
#line 7270 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT && reload_completed))
                return NULL;
              return gen_split_14 (insn, operands);

            case 1:
              if (
#line 7428 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                return gen_split_15 (insn, operands);
              if (!
#line 7447 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed))
                return NULL;
              return gen_split_16 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          switch (pattern63 (x1))
            {
            case 0:
              if (
#line 7761 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT && reload_completed
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                return gen_split_17 (insn, operands);
              if (!
#line 7782 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT && reload_completed))
                return NULL;
              return gen_split_18 (insn, operands);

            case 1:
              if (
#line 8134 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                return gen_split_19 (insn, operands);
              if (!
#line 8155 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed))
                return NULL;
              return gen_split_20 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      if (peep2_current_count < 2)
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_CODE (x2) != PLUS
          || GET_MODE (x2) != SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], SImode))
        return NULL;
      x4 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x4) != SET)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MEM)
        return NULL;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x7 = XEXP (x5, 0);
      if (!rtx_equal_p (x7, operands[0]))
        return NULL;
      x8 = XEXP (x2, 0);
      switch (GET_CODE (x8))
        {
        case ASHIFT:
          if (GET_MODE (x8) != SImode)
            return NULL;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != CONST_INT)
            return NULL;
          x10 = XEXP (x8, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], SImode))
            return NULL;
          x11 = XEXP (x2, 1);
          operands[2] = x11;
          if (!register_operand (operands[2], SImode))
            return NULL;
          switch (XWINT (x9, 0))
            {
            case 2L:
              switch (GET_MODE (x5))
                {
                case SImode:
                  if (!register_operand (operands[3], SImode)
                      || !
#line 2259 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_1 (insn, operands);

                case SFmode:
                  if (!register_operand (operands[3], SFmode)
                      || !
#line 4426 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_10 (insn, operands);

                default:
                  return NULL;
                }

            case 3L:
              if (GET_MODE (x5) != DFmode
                  || !register_operand (operands[3], DFmode)
                  || !
#line 3874 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_6 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          if (!register_operand (x8, SImode))
            return NULL;
          x11 = XEXP (x2, 1);
          switch (GET_CODE (x11))
            {
            case REG:
            case SUBREG:
              operands[2] = x11;
              if (!register_operand (operands[2], SImode))
                return NULL;
              operands[1] = x8;
              switch (GET_MODE (x5))
                {
                case SImode:
                  if (!register_operand (operands[3], SImode))
                    return NULL;
                  if (
#line 2293 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_INDEX_P (operands[1])
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_2 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (!
#line 2310 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_BASE_P (operands[1])
   && REG_OK_FOR_INDEX_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_3 (insn, operands);

                case DFmode:
                  if (!register_operand (operands[3], DFmode))
                    return NULL;
                  if (
#line 3943 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_INDEX_P (operands[1])
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_8 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (!
#line 3960 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_BASE_P (operands[1])
   && REG_OK_FOR_INDEX_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_9 (insn, operands);

                case SFmode:
                  if (!register_operand (operands[3], SFmode))
                    return NULL;
                  if (
#line 4460 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_INDEX_P (operands[1])
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_11 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (!
#line 4477 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_BASE_P (operands[1])
   && REG_OK_FOR_INDEX_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_12 (insn, operands);

                default:
                  return NULL;
                }

            case ASHIFT:
              if (GET_MODE (x11) != SImode)
                return NULL;
              x12 = XEXP (x11, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
                return NULL;
              operands[2] = x8;
              x13 = XEXP (x11, 0);
              operands[1] = x13;
              if (!register_operand (operands[1], SImode)
                  || GET_MODE (x5) != DFmode
                  || !register_operand (operands[3], DFmode)
                  || !
#line 3891 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_7 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 8:
          if (pattern4 (x1) != 0
              || !
#line 3305 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT
   && GET_CODE (operands[0]) == MEM
   && register_operand (XEXP (operands[0], 0), SImode)
   && GET_CODE (operands[1]) == MEM
   && register_operand (XEXP (operands[1], 0), SImode)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_4 (insn, operands);

        case 5:
          x14 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x14) != SET)
            return NULL;
          x15 = XEXP (x14, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x16 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x16) != CLOBBER)
            return NULL;
          x17 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x17) != CLOBBER)
            return NULL;
          x18 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x18) != USE)
            return NULL;
          x19 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x19) != USE
              || pattern45 (x1) != 0
              || !
#line 3624 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT
   && GET_CODE (operands[0]) == MEM
   && register_operand (XEXP (operands[0], 0), SImode)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_5 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
